package Events
{
	import Actions.*;
	
	import Application.*;
	
	import Banks.*;
	
	import Conditions.*;
	
	import Expressions.*;
	
	import Frame.*;
	
	import OI.*;
	
	import Objects.*;
	
	import Params.*;
	
	import RunLoop.*;
	
	import Services.*;
	
	import Sprites.*;
		
	public class CEventProgram
	{
	    public static var EVENTS_EXTBASE:int=80;
	    public static var PARAMCLICK_DOUBLE:int=0x100;
	    
	    public var rhPtr:CRun;
	    public var maxObjects:int;
	    public var maxOi:int=0;
	    public var nPlayers:int;
	    public var nConditions:Array;         // NUMBEROF_SYSTEMTYPES+OBJ_LAST
	    public var nQualifiers:int;
	    public var nEvents:int;
	    public var qualifiers:Array;
	    public var events:Array;
	    public var qualToOiList:Array;
	    public var listPointers:Array;
	    public var eventPointersGroup:Array;
	    public var eventPointersCnd:Array;
	    public var limitBuffer:Array;
	    public var rhEvents:Array;
	    public var rhEventAlways:Boolean;
	    public var rh4TimerEventsBase:int;
	    public var colBuffer:Array;
	    private var qualOilPtr:int;
	    private var qualOilPos:int;
	    private var qualOilPtr2:int;
	    private var qualOilPos2:int;
	    public var rh4CheckDoneInstart:Boolean;			// Build92 to correct start of frame with fade in
	    public var rhEventGroup:CEventGroup;				// Current group
	    public var rhCurCode:int;                                       // Current event
	    public var rh4PickFlags:Array;				// 00-31
	    public var rh2ActionLoop:Boolean;			// Actions flag
	    public var rh2ActionOn:Boolean;			// Flag are we in actions?
	    public var rh2EnablePick:Boolean;  			// Are we in pick for actions?
	    public var rh2EventCount:int;				// Number of the event 
	    public var rh2ActionCount:int;				// Action counter
	    public var rh2ActionLoopCount:int;	  		// Action loops counter
	    public var rh4EventCountOR:int;                         // Number of the event for OR conditions
	    public var rh4ConditionsFalse:Boolean;
	    public var rh3DoStop:Boolean;			// Force the test of stop actions
	    public var rh2EventQualPos:CQualToOiList;          // ***Position in event objects
	    public var rh2EventQualPosNum:int;			// ***Position in event objects
	    public var rh2EventPos:CObject;				// ***Position in event objects
	    public var rh2EventPosOiList:int; 		// ***Position in oilist for TYPE exploration 
	    public var rh2EventPrev:CObject;				// ***Previous object address
	    public var rh2EventPrevOiList:CObjInfo;				// ***Previous object address
	    public var evtNSelectedObjects:int;
	    public var repeatFlag:Boolean;
	    public var rh2EventType:int;
	    public var rhCurOi:int;
	    public var rhCurParam0:int;
	    public var rhCurParam1:int;
	    public var rh3CurrentMenu:int;				// For menu II events
	    public var rh2CurrentClick:int;			// For click events II
	    public var rh4_2ndObject:CObject;	 		// Collision object address
	    public var bReady:Boolean;
	    public var rh2ShuffleBuffer:CArrayList;	
	    public var rhCurObjectNumber:int;	 		// Object number
	    public var rh1stObjectNumber:int;          // Number, for collisions
	  
	    public var rh2PushedEvents:CArrayList;
	    public var rh2ActionEndRoutine:Boolean;		// End of action routine
						
		public function CEventProgram()
		{
	    	nConditions=new Array(7+COI.OBJ_LAST);         // NUMBEROF_SYSTEMTYPES+OBJ_LAST
	    	rhEvents=new Array(COI.NUMBEROF_SYSTEMTYPES+1);
	    	rh4PickFlags=new Array(4);				// 00-31
		}

	    public function bts(array:Array, index:int):Boolean
	    {
	        var d:int=index/32;
	        var mask:int=1<<(index&31);
	        var b:Boolean=(array[d]&mask)!=0;
	        array[d]|=mask;
	        return b;
	    }

	    // -------------------------------------------------------------
	    // EVENEMENT : RECHERCHE D'UN TYPE DEFINI D'OBJETS, AX=TYPE
	    // -------------------------------------------------------------
	    public function evt_FirstObjectFromType(nType:int):CObject
	    {
            var pHo:CObject;
            var oil:int;

	        rh2EventType = nType;
	        if (nType == -1)
	        {
	            var pHoStore:CObject;
	            var poil:CObjInfo;
	            var bStore:Boolean = true;
	            for (oil = 0; oil < rhPtr.rhOiList.length; oil++)
	            {
	                poil = rhPtr.rhOiList[oil];
	                if (bts(rh4PickFlags, poil.oilType) == false)	// Deja vue dans ce groupe d'event (met le flag aussi!) ?
	                {
	                    pHo = evt_SelectAllFromType(poil.oilType, bStore);
	                    if (pHo != null)
	                    {
	                        pHoStore = pHo;
	                        bStore = false;
	                    }
	                }
	            }
	            if (pHoStore != null)
	            {
	                return pHoStore;
	            }
	        }
	        else
	        {
	            if (bts(rh4PickFlags, nType) == false)                    // Deja vue dans ce groupe d'event (met le flag aussi!) ?
	            {
	                return evt_SelectAllFromType(nType, true);		// NON, on selectionne tout et on retourne le premier
	            }
	        }
	
	        oil=0;
	        var oilPtr:CObjInfo;
	        do
	        {
	            oilPtr = rhPtr.rhOiList[oil];
	            if (oilPtr.oilType == nType)
	            {
	                if (oilPtr.oilListSelected >= 0)
	                {
	                    pHo = rhPtr.rhObjectList[oilPtr.oilListSelected];
	                    rh2EventPrev = null;
	                    rh2EventPrevOiList = oilPtr;
	                    rh2EventPos = pHo;
	                    rh2EventPosOiList = oil;
	                    return pHo;
	                }
	            }
	            oil++;									// Un autre OI?
	        } while (oil < rhPtr.rhMaxOI);
	        return null;
	    }

	    // Retourne le suivant
	    // ------------------- 
	    public function evt_NextObjectFromType():CObject
	    {
	        var pHo:CObject = rh2EventPos;
	        var oilPtr:CObjInfo;
	        if (pHo == null)
	        {
	            oilPtr = rhPtr.rhOiList[rh2EventPosOiList];
	            if (oilPtr.oilListSelected >= 0)
	            {
	                pHo = rhPtr.rhObjectList[oilPtr.oilListSelected];
	                rh2EventPrev = null;				// Stocke pour la destruction
	                rh2EventPrevOiList = oilPtr;
	                rh2EventPos = pHo;
	                return pHo;
	            }
	        }
	        if (pHo != null)
	        {
	            if (pHo.hoNextSelected >= 0)
	            {
	                rh2EventPrev = pHo;				// Stocke pour la destruction
	                rh2EventPrevOiList = null;
	                pHo = rhPtr.rhObjectList[pHo.hoNextSelected];
	                rh2EventPos = pHo;
	                return pHo;
	            }
	        }
	
	        var oil:int = rh2EventPosOiList;			// Adresse de l'oilist
	        var nType:int = rhPtr.rhOiList[oil].oilType;
	        oil++;
	        while (oil < rhPtr.rhMaxOI)
	        {
	            if ((rh2EventType != -1 && rhPtr.rhOiList[oil].oilType == nType) || rh2EventType == -1)
	            {
	                if (rhPtr.rhOiList[oil].oilListSelected >= 0)
	                {
	                    pHo = rhPtr.rhObjectList[rhPtr.rhOiList[oil].oilListSelected];
	                    rh2EventPrev = null;
	                    rh2EventPrevOiList = rhPtr.rhOiList[oil];
	                    rh2EventPos = pHo;
	                    rh2EventPosOiList = oil;
	                    return pHo;
	                }
	            }
	            oil++;									// Un autre OI?
	        }
	        return null;
	    }

	    // Selectionne TOUS les objets de meme type, retourne le premier dans EAX
	    // ----------------------------------------------------------------------
	    public function evt_SelectAllFromType(nType:int, bStore:Boolean):CObject
	    {
	        var first:int = -1;
	        var evtCount:int = rh2EventCount;
	        
			rhPtr.debugString=new String();
	        var oil:int = 0;
	        var oilPtr:CObjInfo;
	        var pHo:CObject;
	        do
	        {
	            oilPtr = rhPtr.rhOiList[oil];
	            if (oilPtr.oilType == nType && oilPtr.oilEventCount != evtCount) // Deja selectionne dans cet event?
	            {
	                oilPtr.oilEventCount = evtCount;					// Fabrique la liste
	                if (rh4ConditionsFalse)
	                {
	                    oilPtr.oilListSelected = -1;
	                    oilPtr.oilNumOfSelected = 0;
	                }
	                else
	                {
	                    oilPtr.oilNumOfSelected = oilPtr.oilNObjects;
	                    var num:int = oilPtr.oilObject;
	                    if (num >= 0)
	                    {
	                        if (first == -1 && bStore == true)
	                        {
	                            first = num;					// Stocke le premier pour aller plus vite
	                            rh2EventPrev = null;
	                            rh2EventPrevOiList = oilPtr;
	                            rh2EventPosOiList = oil;
	                        }
	                        do
	                        {
	                            pHo = rhPtr.rhObjectList[num];
	                            pHo.hoNextSelected = pHo.hoNumNext;
	                            num = pHo.hoNumNext;
								rhPtr.debugString+=".";
	                        } while (num >= 0);
	
	                        num = oilPtr.oilObject;
	                    }
	                    oilPtr.oilListSelected = num;
	                }
	            }
	            oil++;										// Un autre OI?
	        } while (oil < rhPtr.rhMaxOI);
			rhPtr.debugString=null;
	        if (bStore == false)
	        {
	            return null;
	        }
	        if (first < 0)
	        {
	            return null;
	        }
	
	        pHo = rhPtr.rhObjectList[first];
	        rh2EventPos = pHo;
	        return pHo;
	    }

	    // -------------------------------------------------------------
	    // EVENEMENT : RECHERCHE DEFINI, EDX=OI
	    // -------------------------------------------------------------
	    public function evt_FirstObject(sEvtOiList:int):CObject
	    {
	        var pHo:CObject;
	
	        evtNSelectedObjects = 0;
	        rh2EventQualPos = null;
	        rh2EventQualPosNum = -1;
	
	        if ((sEvtOiList&0x8000)!=0)
	        {
	            // Selectionne TOUS les objets à partir d'un qualifier
	            // ---------------------------------------------------
	            if ((sEvtOiList&0x7FFF)==0x7FFF)	// -1: pas d'objet du tout dans le jeu!
	            {
	                return null;
	            }
	            // Appel de la procedure
	            return qualProc(sEvtOiList);
	        }
	
	        var oilPtr:CObjInfo = rhPtr.rhOiList[sEvtOiList];
	        if (oilPtr.oilEventCount == rh2EventCount)		// Deja selectionne dans cet event?
	        {
	            // Prend la liste deja exploree dans un event precedent
	            // ----------------------------------------------------
	            if (oilPtr.oilListSelected < 0)
	            {
	                return null;
	            }
	            pHo = rhPtr.rhObjectList[oilPtr.oilListSelected];
	            rh2EventPrev = null;
	            rh2EventPrevOiList = oilPtr;
	            rh2EventPos = pHo;
	            rh2EventPosOiList = sEvtOiList;
	            evtNSelectedObjects = oilPtr.oilNumOfSelected;
	            return pHo;
	        }
	        else
	        {
	            // Selectionne TOUS les objets de meme type, retourne le premier dans EAX
	            // ----------------------------------------------------------------------
	            oilPtr.oilEventCount = rh2EventCount;
	
	            // Si condition OR et conditions fausse, ne selectionne aucun objet
	            if (rh4ConditionsFalse)
	            {
	                oilPtr.oilListSelected = -1;
	                oilPtr.oilNumOfSelected = 0;
	                return null;
	            }
	
	            // Ajoute les objets
	            oilPtr.oilListSelected = oilPtr.oilObject;
	            if (oilPtr.oilObject < 0)
	            {
	                oilPtr.oilNumOfSelected = 0;
	                return null;
	            }
	            var num:int = oilPtr.oilObject;
	            do
	            {
	                pHo = rhPtr.rhObjectList[num];
	                num = pHo.hoNumNext;
	                pHo.hoNextSelected = num;
	            } while (num >= 0);
	
	            pHo = rhPtr.rhObjectList[oilPtr.oilObject];
	            rh2EventPrev = null;
	            rh2EventPrevOiList = oilPtr;
	            rh2EventPos = pHo;
	            rh2EventPosOiList = sEvtOiList;
	            oilPtr.oilNumOfSelected = oilPtr.oilNObjects;
	            evtNSelectedObjects = oilPtr.oilNumOfSelected;
	            return pHo;
	        }
	    }

	    public function qualProc(sEvtOiList:int):CObject
	    {
	        var pHo:CObject;
	        var oilPtr:CObjInfo ;
	        var count:int;
	
	        // Selectionne / Compte tous les objets de tous les groupes
	        var qoi:int;
	        var qoiList:int;
	        var addCount:int;
	        var pQoi:CQualToOiList = qualToOiList[sEvtOiList & 0x7FFF];
	        while (qoi < pQoi.qoiList.length)
	        {
	            qoiList = pQoi.qoiList[qoi + 1];
	            oilPtr = rhPtr.rhOiList[qoiList];
	            if (oilPtr.oilEventCount == rh2EventCount)
	            {
	                // Deja selectionnee dans un evenement precedent
	                addCount = 0;
	                if (oilPtr.oilListSelected >= 0)
	                {
	                    addCount = oilPtr.oilNumOfSelected;
	                    if (rh2EventQualPos == null)
	                    {
	                        rh2EventQualPos = pQoi;
	                        rh2EventQualPosNum = qoi;
	                    }
	                }
	            }
	            else
	            {
	                addCount = 0;
	                oilPtr.oilEventCount = rh2EventCount;
	
	                // Si condition OR et conditions fausse, ne selectionne aucun objet
	                if (rh4ConditionsFalse)
	                {
	                    oilPtr.oilListSelected = -1;
	                    oilPtr.oilNumOfSelected = 0;
	                }
	                else
	                {
	                    oilPtr.oilListSelected = oilPtr.oilObject;
	                    if (oilPtr.oilObject < 0)
	                    {
	                        oilPtr.oilNumOfSelected = 0;
	                    }
	                    else
	                    {
	                        if (rh2EventQualPos == null)
	                        {
	                            rh2EventQualPos = pQoi;
	                            rh2EventQualPosNum = qoi;
	                        }
	                        var num:int = oilPtr.oilObject;
	                        do
	                        {
	                            pHo = rhPtr.rhObjectList[num];
	                            pHo.hoNextSelected = pHo.hoNumNext;
	                            num = pHo.hoNumNext;
	                        } while (num >= 0);
	
	                        oilPtr.oilNumOfSelected = oilPtr.oilNObjects;
	                        addCount = oilPtr.oilNObjects;
	                    }
	                }
	            }
	            count += addCount;
	            qoi += 2;
	        }
	
	        pQoi = rh2EventQualPos;
	        if (pQoi != null)
	        {
	            oilPtr = rhPtr.rhOiList[pQoi.qoiList[rh2EventQualPosNum + 1]];
	            rh2EventPrev = null;
	            rh2EventPrevOiList = oilPtr;
	            pHo = rhPtr.rhObjectList[oilPtr.oilListSelected];
	            rh2EventPos = pHo;
	            rh2EventPosOiList = pQoi.qoiList[rh2EventQualPosNum + 1];
	            evtNSelectedObjects = count;
	            return pHo;
	        }
	        return null;
	    }

	    // ------------------------
	    // RETOURNE L'OBJET SUIVANT
	    // ------------------------
	    public function evt_NextObject():CObject
	    {
	        var pHo:CObject = rh2EventPos;
	        var oilPtr:CObjInfo;
	        if (pHo == null)
	        {
	            oilPtr = rhPtr.rhOiList[rh2EventPosOiList];
	            if (oilPtr.oilListSelected >= 0)
	            {
	                pHo = rhPtr.rhObjectList[oilPtr.oilListSelected];
	                rh2EventPrev = null;				// Stocke pour la destruction
	                rh2EventPrevOiList = oilPtr;
	                rh2EventPos = pHo;
	                return pHo;
	            }
	        }
	        if (pHo != null)
	        {
	            if (pHo.hoNextSelected >= 0)
	            {
	                rh2EventPrev = pHo;				// Stocke pour la destruction
	                rh2EventPrevOiList = null;
	                pHo = rhPtr.rhObjectList[pHo.hoNextSelected];
	                rh2EventPos = pHo;
	                return pHo;
	            }
	        }
	        if (rh2EventQualPos == null)			// Une liste de qualifiers?
	        {
	            return null;
	        }
	
	        // Prend la liste de qualifier suivante
	        // ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	        do
	        {
	            rh2EventQualPosNum += 2;
	            if (rh2EventQualPosNum >= rh2EventQualPos.qoiList.length)
	            {
	                return null;
	            }
	            oilPtr = rhPtr.rhOiList[rh2EventQualPos.qoiList[rh2EventQualPosNum + 1]];
	        } while (oilPtr.oilListSelected < 0);
	
	        rh2EventPrev = null;
	        rh2EventPrevOiList = oilPtr;
	        pHo = rhPtr.rhObjectList[oilPtr.oilListSelected];
	        rh2EventPos = pHo;
	        rh2EventPosOiList = rh2EventQualPos.qoiList[rh2EventQualPosNum + 1];
	        return pHo;
	    }

	    // -------------------------------------------------
	    // SELECTIONNE TOUS LES OBJETS RELIES A UN QUALIFIER
	    // -------------------------------------------------
	    public function evt_AddCurrentQualifier(qual:int):void
	    {
	        var pQoi:CQualToOiList = qualToOiList[qual & 0x7FFF];
	        var noil:int = 0;
	        var oilPtr:CObjInfo;
	        while (noil < pQoi.qoiList.length)
	        {
	            oilPtr = rhPtr.rhOiList[pQoi.qoiList[noil + 1]];
	            if (oilPtr.oilEventCount != rh2EventCount)
	            {
	                oilPtr.oilEventCount = rh2EventCount;
	                oilPtr.oilNumOfSelected = 0;
	                oilPtr.oilListSelected = -1;
	            }
	            noil += 2;
	        };
	    }

	    // ----------------------------------------------------------
	    // ENLEVE L'OBJET COURANT DE LA LISTE DES OBJETS SELECTIONNES
	    // ----------------------------------------------------------
	    public function evt_DeleteCurrentObject():void
	    {
	        rh2EventPos.hoOiList.oilNumOfSelected -= 1;					// Un de moins dans l'OiList
	        if (rh2EventPrev != null)
	        {
	            rh2EventPrev.hoNextSelected = rh2EventPos.hoNextSelected;
	            rh2EventPos = rh2EventPrev;                                           // Car le courant est vire!
	        }
	        else
	        {
	//            rhPtr.rhOiList[rh2EventPosOiList].oilListSelected=rh2EventPos.hoNextSelected;
	            rh2EventPrevOiList.oilListSelected = rh2EventPos.hoNextSelected;
	            rh2EventPos = null;
	        }
	    }

	    // -----------------------------------------------
	    // ADDITIONNE L'OBJET EAX A LA LISTE SI NECESSAIRE
	    // -----------------------------------------------
	    public function evt_AddCurrentObject(pHo:CObject):void
	    {
	        var oilPtr:CObjInfo = pHo.hoOiList;
	        if (oilPtr.oilEventCount != rh2EventCount)
	        {
	            // Aucune selection
	            oilPtr.oilEventCount = rh2EventCount;
	            oilPtr.oilListSelected = pHo.hoNumber;
	            oilPtr.oilNumOfSelected = 1;
	            pHo.hoNextSelected = -1;
	        }
	        else
	        {
	            // Objet deja selectionne, evite les doublets
	            var oils:int = oilPtr.oilListSelected;
	            if (oils < 0)
	            {
	                oilPtr.oilListSelected = pHo.hoNumber;
	                oilPtr.oilNumOfSelected += 1;
	                pHo.hoNextSelected = -1;
	            }
	            else
	            {
	                var pHo1:CObject;
	                do
	                {
	                    if (pHo.hoNumber == oils)
	                    {
	                        return;
	                    }
	                    pHo1 = rhPtr.rhObjectList[oils];
	                    oils = pHo1.hoNextSelected;
	                } while (oils >= 0);
	
	                pHo1.hoNextSelected = pHo.hoNumber;
	                pHo.hoNextSelected = -1;
	                pHo.hoOiList.oilNumOfSelected += 1;
	            }
	        }
	    }

	    // -------------------------------------------
	    // FORCE L'OBJET EAX SEUL DANS SA PROPRE LISTE
	    // -------------------------------------------
	    public function deselectThem(oil:int):void
	    {
	        var poil:CObjInfo = rhPtr.rhOiList[oil];		// Pointe la liste
	        poil.oilEventCount = rh2EventCount;
	        poil.oilListSelected = -1;
	        poil.oilNumOfSelected = 0;
	    }

	    public function evt_ForceOneObject(oil:int, pHo:CObject):void
	    {
	        // Deselectionne tous les objets de meme oil
	        if ((oil&0x8000)==0)
	        {
	            // Un identifier normal
	            deselectThem(oil);
	        }
			else
			{
		        // Un qualifier
		        if ((oil&0x7FFF)==0x7FFF)
		        {
		            return;
		        }
		        var pqoi:CQualToOiList = qualToOiList[oil & 0x7FFF];
		        var qoi:int;
		        for (qoi = 0; qoi < pqoi.qoiList.length; qoi += 2)
		        {
		            deselectThem(pqoi.qoiList[qoi + 1]);
		        }
			}
	        // Selects the only one
	        pHo.hoNextSelected = -1;
	        pHo.hoOiList.oilListSelected = pHo.hoNumber;
	        pHo.hoOiList.oilNumOfSelected = 1;
	        pHo.hoOiList.oilEventCount = rh2EventCount;
	    }

	    // -----------------------------------------------
	    // FORCE TOUT UN TYPE EN PICK, DESELECTIONNE TOUT
	    // -----------------------------------------------
	    public function evt_DeleteCurrentType(nType:int):void
	    {
	        bts(rh4PickFlags, nType);
	
	        var oil:int;
	        var oilPtr:CObjInfo;
	        for (oil = 0; oil < rhPtr.rhMaxOI; oil++)
	        {
	            oilPtr = rhPtr.rhOiList[oil];
	            if (oilPtr.oilType == nType)
	            {
	                oilPtr.oilEventCount = rh2EventCount;
	                oilPtr.oilListSelected = -1;
	                oilPtr.oilNumOfSelected = 0;
	            }
	        }
	    }

	    // Deslectionne tous les objets courants
	    public function evt_DeleteCurrent():void
	    {
	        rh4PickFlags[0] = -1;
	        rh4PickFlags[1] = -1;
	        rh4PickFlags[2] = -1;
	        rh4PickFlags[3] = -1;
	
	        var oil:int;
	        var oilPtr:CObjInfo;
	        for (oil = 0; oil < rhPtr.rhMaxOI; oil++)
	        {
	            oilPtr = rhPtr.rhOiList[oil];
	            oilPtr.oilEventCount = rh2EventCount;
	            oilPtr.oilListSelected = -1;
	            oilPtr.oilNumOfSelected = 0;
	        }
	    }

	    // ---------------------------------------------------
	    // Gestion des OU dans les objets
	    // ---------------------------------------------------
	    public function evt_MarkSelectedObjects():void
	    {
	        var num:int;
	        var pHO:CObject;
	        var oil:int;
	        var oilPtr:CObjInfo;
	
	        for (oil = 0; oil < rhPtr.rhMaxOI; oil++)
	        {
	            oilPtr = rhPtr.rhOiList[oil];
	            if (oilPtr.oilEventCount == rh2EventCount)
	            {
	                if (oilPtr.oilEventCountOR != rh4EventCountOR)
	                {
	                    oilPtr.oilEventCountOR = rh4EventCountOR;
	                    num = oilPtr.oilObject;
	                    while (num >= 0)
	                    {
	                        pHO = rhPtr.rhObjectList[num];
	                        pHO.hoSelectedInOR = 0;
	                        num = pHO.hoNumNext;
	                    }
	                }
	                num = oilPtr.oilListSelected;
	                while (num >= 0)
	                {
	                    pHO = rhPtr.rhObjectList[num];
	                    pHO.hoSelectedInOR = 1;
	                    num = pHO.hoNextSelected;
	                }
	            }
	        }
	    }

	    // Branche les objets selectionnes dans les OU
	    public function evt_BranchSelectedObjects():void
	    {
	        var num:int;
	        var pHO:CObject, pHOPrev:CObject;
	        var oil:int;
	        var oilPtr:CObjInfo;
	
	        for (oil = 0; oil < rhPtr.rhMaxOI; oil++)
	        {
	            oilPtr = rhPtr.rhOiList[oil];
	            if (oilPtr.oilEventCountOR == rh4EventCountOR)
	            {
	                oilPtr.oilEventCount = rh2EventCount;
	
	                num = oilPtr.oilObject;
	                pHOPrev = null;
	                while (num >= 0)
	                {
	                    pHO = rhPtr.rhObjectList[num];
	                    if (pHO.hoSelectedInOR != 0)
	                    {
	                        if (pHOPrev != null)
	                        {
	                            pHOPrev.hoNextSelected = num;
	                        }
	                        else
	                        {
	                            oilPtr.oilListSelected = num;
	                        }
	                        pHO.hoNextSelected = -1;
	                        pHOPrev = pHO;
	                    }
	                    num = pHO.hoNumNext;
	                }
	            }
	        }
	    }

	    // ---------------------------------------------------
	    // TROUVE L'OBJET COURANT POUR LES EXPRESSIONS >>> ESI
	    // ---------------------------------------------------
	    public function get_ExpressionObjects(expoi:int):CObject
	    {
	        if (rh2ActionOn)					// On est dans les actions ?
	        {
	            // Dans une action
	            rh2EnablePick = false;					// En cas de chooseflag
	            return get_CurrentObjects(expoi);	// Pointe l'oiList
	        }
	
	        // Dans un evenement
	        // -----------------
	        var oilPtr:CObjInfo;
	        if ((expoi&0x8000)==0)
	        {
	            oilPtr = rhPtr.rhOiList[expoi];
	            if (oilPtr.oilEventCount == rh2EventCount)		// Selection actuelle?
	            {
	                if (oilPtr.oilListSelected >= 0)			// Le premier
	                {
	                    return rhPtr.rhObjectList[oilPtr.oilListSelected];
	                }
	                if (oilPtr.oilObject >= 0)					// Prend le premier objet
	                {
	                    return rhPtr.rhObjectList[oilPtr.oilObject];
	                }
	
	                // Pas d'objet!
	                // ~~~~~~~~~~~~
	                return null;
	            }
	            else
	            {
	                if (oilPtr.oilObject >= 0)					// Prend le premier objet
	                {
	                    return rhPtr.rhObjectList[oilPtr.oilObject];
	                }
	
	                // Pas d'objet!
	                // ~~~~~~~~~~~~
	                return null;
	            }
	        }
	
	        // Un qualifier: trouve la premiere liste selectionnee
	        // ---------------------------------------------------
	        var pQoi:CQualToOiList = qualToOiList[expoi & 0x7FFF];
	        var qoi:int = 0;
	        if (qoi >= pQoi.qoiList.length)
	        {
	            return null;
	        }
	        // Recherche un objet selectionne
	        do
	        {
	            oilPtr = rhPtr.rhOiList[pQoi.qoiList[qoi + 1]];
	            if (oilPtr.oilEventCount == rh2EventCount)
	            {
	                if (oilPtr.oilListSelected >= 0)	// Le premier selectionne?
	                {
	                    return rhPtr.rhObjectList[oilPtr.oilListSelected];
	                }
	            }
	            qoi += 2;
	        } while (qoi < pQoi.qoiList.length);
	
	        // Pas trouve: prend le premier de la premiere liste disponible
	        qoi = 0;
	        do
	        {
	            oilPtr = rhPtr.rhOiList[pQoi.qoiList[qoi + 1]];
	            if (oilPtr.oilObject >= 0)							// Le premier selectionne?
	            {
	                return rhPtr.rhObjectList[oilPtr.oilObject];
	            }
	            qoi += 2;
	        } while (qoi < pQoi.qoiList.length);
	
	        return null;
	    }

	    // ----------------------------------------------------------------------
	    // TROUVE L'OBJET COURANT POUR UN PARAMETRE PARAM_OBJECT DANS UNE ACTION
	    // ----------------------------------------------------------------------
	    public function get_ParamActionObjects(qoil:int, pAction:CAct):CObject
	    {
	        rh2EnablePick = true;
	        var pObject:CObject = get_CurrentObjects(qoil);
	        if (pObject != null)
	        {
	            if (repeatFlag == false)
	            {
	                // Pas de suivant
	                pAction.evtFlags &= ~CAct.ACTFLAGS_REPEAT;		// Ne pas refaire cette action
	                return pObject;
	            }
	            else
	            {
	                // Un suivant
	                pAction.evtFlags |= CAct.ACTFLAGS_REPEAT;		// Refaire cette action
	                rh2ActionLoop = true;			 	// Refaire un tour d'actions
	                return pObject;
	            }
	        }
	        pAction.evtFlags &= ~CAct.ACTFLAGS_REPEAT;				// Ne pas refaire cette action
	        pAction.evtFlags |= CEvent.EVFLAGS_NOTDONEINSTART;
	        return pObject;
	    }

	    // ----------------------------------------------------------------------
	    // TROUVE L'OBJET COURANT POUR LES ACTIONS, MARQUE LES ACTIONS A REFAIRE
	    // ----------------------------------------------------------------------
	    public function get_ActionObjects(pAction:CAct):CObject
	    {
	        pAction.evtFlags &= ~CEvent.EVFLAGS_NOTDONEINSTART;
	        rh2EnablePick = true;
	        var qoil:int = pAction.evtOiList;				// Pointe l'oiList
	        var pObject:CObject = get_CurrentObjects(qoil);
	        if (pObject != null)
	        {
	            if (repeatFlag == false)
	            {
	                // Pas de suivant
	                pAction.evtFlags &= ~CAct.ACTFLAGS_REPEAT;		// Ne pas refaire cette action
	                return pObject;
	            }
	            else
	            {
	                // Un suivant
	                pAction.evtFlags |= CAct.ACTFLAGS_REPEAT;		// Refaire cette action
	                rh2ActionLoop = true;			 	// Refaire un tour d'actions
	                return pObject;
	            }
	        }
	        pAction.evtFlags &= ~CAct.ACTFLAGS_REPEAT;				// Ne pas refaire cette action
	        pAction.evtFlags |= CEvent.EVFLAGS_NOTDONEINSTART;
	        return pObject;
	    }

	    // --------------------------------------------------------------------------
	    // Retourne un objet pour une action. Entree EDX=OiList. Change tout sauf EDI
	    // --------------------------------------------------------------------------
	    public function get_CurrentObjects(qoil:int):CObject
	    {
	        if ((qoil&0x8000)==0)
	        {
	            return get_CurrentObject(qoil);
	        }
	        return get_CurrentObjectQualifier(qoil);
	    }

	    // -----------------------------------
	    // GET ACTION OBJECT POUR OBJET NORMAL
	    // -----------------------------------
	    public function get_CurrentObject(qoil:int):CObject
	    {
	        var pHo:CObject;
	        var oilPtr:CObjInfo = rhPtr.rhOiList[qoil];
	
	        if (oilPtr.oilActionCount != rh2ActionCount)	//; Premiere exploration?
	        {
	            oilPtr.oilActionCount = rh2ActionCount;			//; C'est fait pour cette action
	            oilPtr.oilActionLoopCount = rh2ActionLoopCount;
	
	            // On recherche le premier dans la liste courante
	            // ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	            if (oilPtr.oilEventCount == rh2EventCount)	//; Liste vraiment courante?
	            {
	                if (oilPtr.oilListSelected >= 0)					//; La liste des objets selectionnes
	                {
	                    oilPtr.oilCurrentOi = oilPtr.oilListSelected;
	                    pHo = rhPtr.rhObjectList[oilPtr.oilListSelected];
	                    oilPtr.oilNext = pHo.hoNextSelected;		//; Numero de l'objet suivant
	                    if (pHo.hoNextSelected < 0)
	                    {
	                        oilPtr.oilNextFlag = false;				//; Pas de suivant!
	                        oilPtr.oilCurrentRoutine = 1;                     // gao2ndOneOnly;
	                        repeatFlag = false;
	                        return pHo;
	                    }
	                    oilPtr.oilNextFlag = true;					//; Un suivant!
	                    oilPtr.oilCurrentRoutine = 2;                         // gao2ndCurrent;
	                    repeatFlag = true;
	                    return pHo;
	                }
	            }
	
	            // Objet non trouve, on prends tous les objets de meme oi
	            // ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	            if (rh2EnablePick)						//; Pick autorise?
	            {
	                if (oilPtr.oilEventCount == rh2EventCount)	//; Alors juste cet objet?
	                {
	                    oilPtr.oilCurrentRoutine = 0;                     // gao2ndNone;
	                    oilPtr.oilCurrentOi = -1;						// Pas de suivant
	                    return null;
	                }
	            }
	            if (oilPtr.oilObject >= 0)							//; Le numero du premier objet Est-il defini?
	            {
	                oilPtr.oilCurrentOi = oilPtr.oilObject;			//; Stocke le numero de l'objet courant
	                pHo = rhPtr.rhObjectList[oilPtr.oilObject];
	                if (pHo == null)
	                {
	                    oilPtr.oilCurrentRoutine = 0;                     // gao2ndNone;
	                    oilPtr.oilCurrentOi = -1;						// Pas de suivant
	                    return null;
	                }
	                if (pHo.hoNumNext >= 0)
	                {
	                    // Plusieurs objets
	                    oilPtr.oilNext = pHo.hoNumNext;				// Numero de l'objet
	                    oilPtr.oilNextFlag = true;						// Un suivant!
	                    oilPtr.oilCurrentRoutine = 3;                 // gao2ndAll;
	                    repeatFlag = true;
	                    return pHo;
	                }
	                // Un seul objet
	                oilPtr.oilNextFlag = false;							// Pas de suivant!
	                oilPtr.oilCurrentRoutine = 1;                     // gao2ndOneOnly;
	                repeatFlag = false;
	                return pHo;
	            }
	            else
	            {
	                oilPtr.oilCurrentRoutine = 0;                     // gao2ndNone;
	                oilPtr.oilCurrentOi = -1;						// Pas de suivant
	                return null;
	            }
	        }
	
	        if (oilPtr.oilActionLoopCount != rh2ActionLoopCount)
	        {
	           	var next:int;
	            oilPtr.oilActionLoopCount = rh2ActionLoopCount;	//; C'est fait pour cette boucle
	            switch (oilPtr.oilCurrentRoutine)
	            {
	                // Pas d'objet
	                case 0:                             // gao2ndNone
	                    repeatFlag = oilPtr.oilNextFlag;
	                    return null;
	                // Un seul objet
	                case 1:                             // gao2ndOneOnly
	                    pHo = rhPtr.rhObjectList[oilPtr.oilCurrentOi];
	                    repeatFlag = oilPtr.oilNextFlag;
	                    return pHo;
	                // Objet suivant dans la liste courante
	                case 2:                             // gao2ndCurrent
	                    oilPtr.oilCurrentOi = oilPtr.oilNext;					//; Numero de l'objet suivant
	                    pHo = rhPtr.rhObjectList[oilPtr.oilNext];
	                    if (pHo == null)
	                    {
	                        return null;
	                    }
	                    next = pHo.hoNextSelected;
	                    if (next < 0)
	                    {
	                        oilPtr.oilNextFlag = false;							// Plus de suivant!
	                        next = oilPtr.oilListSelected;
	                    }
	                    oilPtr.oilNext = next;
	                    repeatFlag = oilPtr.oilNextFlag;
	                    return pHo;
	                // Objet suivant global
	                case 3:                             // gao2ndAll
	                    oilPtr.oilCurrentOi = oilPtr.oilNext;					//; Stocke le numero de l'objet courant
	                    pHo = rhPtr.rhObjectList[oilPtr.oilNext];
	                    if (pHo == null)
	                    {
	                        return null;
	                    }
	                    next = pHo.hoNumNext;
	                    if (next < 0)
	                    {
	                        oilPtr.oilNextFlag = false;							// Pas de suivant!
	                        next = oilPtr.oilObject;							// Repart au debut
	                    }
	                    oilPtr.oilNext = next;
	                    repeatFlag = oilPtr.oilNextFlag;
	                    return pHo;
	            }
	        }
	        if (oilPtr.oilCurrentOi < 0)
	        {
	            return null;					//; Prend l'objet courant
	        }
	        pHo = rhPtr.rhObjectList[oilPtr.oilCurrentOi];
	        repeatFlag = oilPtr.oilNextFlag;
	        return pHo;
	    }

	    // GESTION GETACTION OBJECT AVEC QUALIFIER
	    // --------------------------------------------------------------------------
	    public function get_CurrentObjectQualifier(qoil:int):CObject
	    {
	        var pHo:CObject;
	        var next:int, num:int;
	
	        var pqoi:CQualToOiList = qualToOiList[qoil & 0x7FFF];
	        if (pqoi.qoiActionCount != rh2ActionCount)			//; Premiere exploration?
	        {
	            // PREMIERE EXPLORATION
	            // --------------------
	            pqoi.qoiActionCount = rh2ActionCount;			//; C'est fait pour cette action
	            pqoi.qoiActionLoopCount = rh2ActionLoopCount;
	
	            // On recherche le premier dans les liste courantes
	            // ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	            num = qoi_GetFirstListSelected(pqoi);					//; La premiere liste avec objet selectionne
	            if (num >= 0)
	            {
	                pqoi.qoiCurrentOi = num;
	                pHo = rhPtr.rhObjectList[num];
	                if (pHo == null)
	                {
	                    pqoi.qoiCurrentRoutine = 0;           // qoi2ndNone;
	                    pqoi.qoiCurrentOi = -1;						// Pas de suivant!
	                    return null;
	                }
	                next = pHo.hoNextSelected;
	                if (next < 0)
	                {
	                    next = qoi_GetNextListSelected(pqoi);
	                    if (next < 0)
	                    {
	                        pqoi.qoiCurrentRoutine = 1;       // qoi2ndOneOnly;
	                        pqoi.qoiNextFlag = false;
	                        repeatFlag = false;
	                        return pHo;
	                    }
	                }
	                pqoi.qoiNext = next;
	                pqoi.qoiCurrentRoutine = 2;               // qoi2ndCurrent;
	                pqoi.qoiNextFlag = true;							// Un suivant!
	                repeatFlag = true;
	                return pHo;
	            }
	
	            // Prendre tous?
	            // ~~~~~~~~~~~~~
	            if (rh2EnablePick)						// Pick autorisé?
	            {
	                if (pqoi.qoiSelectedFlag)					//; Une des listes a ete vue pendant les conditions
	                {
	                    pqoi.qoiCurrentRoutine = 0;           // qoi2ndNone;
	                    pqoi.qoiCurrentOi = -1;						// Pas de suivant!
	                    return null;
	                }
	            }
	            num = qoi_GetFirstList(pqoi);
	            if (num >= 0)
	            {
	                pqoi.qoiCurrentOi = num;							//; Stocke le numero de l'objet courant
	                pHo = rhPtr.rhObjectList[num];
	                if (pHo != null)
	                {
	                    num = pHo.hoNumNext;
	                    if (num < 0)
	                    {
	                        num = qoi_GetNextList(pqoi);
	                        if (num < 0)
	                        {
	                            pqoi.qoiCurrentRoutine = 1;               // qoi2ndOneOnly;
	                            pqoi.qoiNextFlag = false;
	                            repeatFlag = false;
	                            return pHo;
	                        }
	                    }
	                    pqoi.qoiNext = num;							// Numero de l'objet
	                    pqoi.qoiCurrentRoutine = 3;                       // qoi2ndAll;
	                    pqoi.qoiNextFlag = true;						// Un suivant
	                    repeatFlag = true;
	                    return pHo;
	                }
	            }
	            pqoi.qoiCurrentRoutine = 0;       // qoi2ndNone;
	            pqoi.qoiCurrentOi = -1;						// Pas de suivant!
	            return null;
	        }
	
	        if (pqoi.qoiActionLoopCount != rh2ActionLoopCount)		//; Premiere fois dans la boucle?
	        {
	            pqoi.qoiActionLoopCount = rh2ActionLoopCount;		//; C'est fait pour cette boucle
	            switch (pqoi.qoiCurrentRoutine)
	            {
	                // Pas d'objet
	                case 0:                 // qoi2ndNone
	                    repeatFlag = pqoi.qoiNextFlag;
	                    return null;
	                // Un seul objet
	                case 1:                 // qoi2ndOneOnly
	                    pHo = rhPtr.rhObjectList[pqoi.qoiCurrentOi];
	                    repeatFlag = pqoi.qoiNextFlag;
	                    return pHo;
	                // Objet suivant dans la liste courante
	                case 2:                 // qoi2ndCurrent
	                    pqoi.qoiCurrentOi = pqoi.qoiNext;					// Numero de l'objet suivant
	                    pHo = rhPtr.rhObjectList[pqoi.qoiNext];
	                    if (pHo != null)
	                    {
	                        next = pHo.hoNextSelected;
	                        if (next < 0)
	                        {
	                            next = qoi_GetNextListSelected(pqoi);
	                            if (next < 0)
	                            {
	                                pqoi.qoiNextFlag = false;					// Plus de suivant!
	                                next = qoi_GetFirstListSelected(pqoi);                    // Repart au debut
	                            }
	                        }
	                        pqoi.qoiNext = next;
	                    }
	                    repeatFlag = pqoi.qoiNextFlag;
	                    return pHo;
	                // Objet suivant global
	                case 3:                 // qoi2ndAll
	                    pqoi.qoiCurrentOi = pqoi.qoiNext;					// Numero de l'objet suivant
	                    pHo = rhPtr.rhObjectList[pqoi.qoiNext];
	                    if (pHo != null)
	                    {
	                        next = pHo.hoNumNext;
	                        if (next < 0)
	                        {
	                            next = qoi_GetNextList(pqoi);
	                            if (next < 0)
	                            {
	                                pqoi.qoiNextFlag = false;					// Plus de suivant
	                                next = qoi_GetFirstList(pqoi);			// Repart au debut
	                            }
	                        }
	                        pqoi.qoiNext = next;
	                    }
	                    repeatFlag = pqoi.qoiNextFlag;
	                    return pHo;
	            }
	        }
	
	        if (pqoi.qoiCurrentOi < 0)
	        {
	            return null;
	        }
	        pHo = rhPtr.rhObjectList[pqoi.qoiCurrentOi];
	        repeatFlag = pqoi.qoiNextFlag;
	        return pHo;
	    }

	    // Trouve la prochaine liste avec des objets selectionnes
	    // ------------------------------------------------------
	    public function qoi_GetNextListSelected(pqoi:CQualToOiList):int
	    {
	        var pos:int = pqoi.qoiActionPos;
	        var qoil:int;
	        var oilPtr:CObjInfo;
	        while (pos < pqoi.qoiList.length)
	        {
	            qoil = pqoi.qoiList[pos + 1];
	            oilPtr = rhPtr.rhOiList[qoil];
	            if (oilPtr.oilEventCount == rh2EventCount)	//; Liste vue pendant les conditions?
	            {
	                pqoi.qoiSelectedFlag = true;						//; Flag: une des liste a ete selectionnee?
	                if (oilPtr.oilListSelected >= 0)
	                {
	                    pqoi.qoiActionPos = (pos + 2);
	                    return oilPtr.oilListSelected;
	                }
	            }
	            pos += 2;
	        }										//; La derniere?
	        return -1;
	    }

	    public function qoi_GetFirstListSelected(pqoi:CQualToOiList):int
	    {
	        pqoi.qoiActionPos = 0;
	        pqoi.qoiSelectedFlag = false;
	        return qoi_GetNextListSelected(pqoi);
	    }

	    // Trouve la prochaine liste avec des objets
	    // -----------------------------------------
	    public function qoi_GetNextList(pqoi:CQualToOiList):int
	    {
	        var pos:int = pqoi.qoiActionPos;
	        var qoil:int;
	        var oilPtr:CObjInfo;
	        while (pos < pqoi.qoiList.length)
	        {
	            qoil = pqoi.qoiList[pos + 1];
	            oilPtr = rhPtr.rhOiList[qoil];
	            if (oilPtr.oilObject >= 0)
	            {
	                pqoi.qoiActionPos = (pos + 2);
	                return oilPtr.oilObject;
	            }
	            pos += 2;
	        }
	        return -1;
	    }

	    public function qoi_GetFirstList(pqoi:CQualToOiList):int
	    {
	        pqoi.qoiActionPos = 0;
	        return qoi_GetNextList(pqoi);
	    }

	    // ---------------------------------------------------------------------------
	    // Entree traitement events non relie a un objet, n'arrete pas le moniteur
	    // ---------------------------------------------------------------------------
	    public function handle_GlobalEvents(code:int):void
	    {
	        var type:int = code & 0xFFFF;
	        if ((type&0x8000)!=0)
	        {
	        	type=65536-type;
	        }
	        var cond:int = -(code >> 16);
	        var num:int = listPointers[rhEvents[type] + cond];
	        if (num != 0)
	        {
	            computeEventList(num, null);		// Evalue les evenements
	        }
	    }

	    // ---------------------------------------------------------------------------
	    // Entree traitement evenement lie a un objet
	    // ---------------------------------------------------------------------------	
	    public function handle_Event(pHo:CObject, code:int):Boolean
	    {
	        rhCurCode = code; 				// Stocke pour access rapide
	
	        // Des evenements definis?
	        // ~~~~~~~~~~~~~~~~~~~~~~~
	        var cond:int = -(code >> 16);				// Vire le type
	        var num:int = listPointers[pHo.hoEvents + cond];
	        if (num != 0)						// Un pointeur direct?
	        {
	            computeEventList(num, pHo);     // Evalue les evenements
				return true;
	        }
			return false;
	    }

	    // ---------------------------------------------------------------------------
	    // 	VERIFIE ET APPELLE LA LISTE DES EVENEMENTS TIMER
	    // ---------------------------------------------------------------------------
	    public function compute_TimerEvents():void
	    {
	        var num:int;
	
	        // Avant le fade-in : que les evenements START OF GAME
	        // ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	        if ((rhPtr.rhGameFlags & CRun.GAMEFLAGS_FIRSTLOOPFADEIN) != 0)
	        {
	            num = listPointers[rhEvents[-COI.OBJ_GAME] + 1];            // -NUM_START
	            if (num != 0)
	            {
	                listPointers[rhEvents[-COI.OBJ_GAME] + 1] = -1;
	                computeEventList(num, null);
	                rh4CheckDoneInstart = true;
	            }
	            return;
	        }
	
	        // Les evenements timer
	        // ~~~~~~~~~~~~~~~~~~~~
	        num = listPointers[rhEvents[-COI.OBJ_TIMER] + 3];               // -NUM_TIMER
	        if (num != 0)
	        {
	            computeEventList(num, null);
	        }
	
	        // Les evenements start of game
	        // ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	        num = listPointers[rhEvents[-COI.OBJ_GAME] + 1];                // -NUM_START
	        var num2:int, count:int;
	        var evgPtr:CEventGroup, evgGroup:CEventGroup;
	        var evtPtr:CEvent;
	        if (num != 0)
	        {
	            if (rh4CheckDoneInstart)
	            {
	                // Marque DONEBEFOREFADEIN les actions déja effectuees : elle ne seront pas réeffectuées...
	                evgGroup = null;
	                num2 = num;
	                do
	                {
	                    evgPtr = eventPointersGroup[num2];
	                    if (evgPtr != evgGroup)
	                    {
	                        evgGroup = evgPtr;
	
	                        // Stoppe les actions deja effectuees
	                        for (count = evgPtr.evgNCond; count < evgPtr.evgNCond + evgPtr.evgNAct; count++)
	                        {
	                            evtPtr = evgPtr.evgEvents[count];
	                            if ((evtPtr.evtFlags & CEvent.EVFLAGS_NOTDONEINSTART) == 0)		// Une action BAD?
	                            {
	                                evtPtr.evtFlags |= CEvent.EVFLAGS_DONEBEFOREFADEIN;
	                            }
	                        }
	                    }
	                    num2++;
	                } while (eventPointersGroup[num2] != null);
	            }
	            computeEventList(num, null);
	            listPointers[rhEvents[-COI.OBJ_GAME] + 1] = 0;		// Une seule fois
	            if (rh4CheckDoneInstart)
	            {
	                // Enleve les flags	
	                evgGroup = null;
	                num2 = num;
	                do
	                {
	                    evgPtr = eventPointersGroup[num2];
	                    if (evgPtr != evgGroup)
	                    {
	                        evgGroup = evgPtr;
	                        // Enleve le flag
	                        for (count = evgPtr.evgNCond; count < evgPtr.evgNCond + evgPtr.evgNAct; count++)
	                        {
	                            evtPtr = evgPtr.evgEvents[count];
	                            evtPtr.evtFlags &= ~CEvent.EVFLAGS_DONEBEFOREFADEIN;
	                        }
	                    }
	                    num2++;
	                } while (eventPointersGroup[num2] != null);
	                rh4CheckDoneInstart = false;
	            }
	        }
	
	        // Les evenements timer inferieur
	        // ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	        num = listPointers[rhEvents[-COI.OBJ_TIMER] + 2];            // -NUM_TIMERINF
	        if (num != 0)
	        {
	            computeEventList(num, null);
	        }
	
	        // Les evenements timer superieur
	        // ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	        num = listPointers[rhEvents[-COI.OBJ_TIMER] + 1];            // -NUM_TIMERSUP
	        if (num != 0)
	        {
	            computeEventList(num, null);
	        }
	    }

	    public function restartTimerEvents():void
	    {
	        var time:int = rhPtr.rhTimer;
	
	        var num:int = listPointers[rhEvents[-COI.OBJ_TIMER] + 3];               // -NUM_TIMER
	        var evtPtr:CEvent;
	        var evgPtr:CEventGroup;
	        if (num != 0)
	        {
	            do
	            {
	                evgPtr = eventPointersGroup[num];
	                evtPtr = evgPtr.evgEvents[eventPointersCnd[num]];
	                evtPtr.evtFlags |= CEvent.EVFLAGS_DONE;		    // Marque l'evenement
	                var p:PARAM_TIME = PARAM_TIME(evtPtr.evtParams[0]);
	                if (p.timer > time)	// Compare au timer
	                {
	                    evtPtr.evtFlags &= ~CEvent.EVFLAGS_DONE;
	                }
	                num++;
	            } while (eventPointersGroup[num] != null);
	        }
	    }

	    // ---------------------------------------------------------------------------
	    // 	EVALUE ET EXECUTE UNE LISTE D'EVENEMENTS
	    // ---------------------------------------------------------------------------
	    public function computeEventList(num:int, pHo:CObject):void
	    {
	        var bTrue:Boolean;
	        var evgPtr:CEventGroup, evgPtr2:CEventGroup;
	        var count:int;
	
	        // Evaluation des evenements pour ce sprite
	        // ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	        rh3DoStop = false;						// En cas de STOP dans les actions
	        do
	        {
	            evgPtr = eventPointersGroup[num];
	
	            if ((evgPtr.evgFlags & CEventGroup.EVGFLAGS_INACTIVE) == 0)	// Un groupe inhibe?
	            {
	                rhEventGroup = evgPtr;					// Adresse du groupe
	                rh4PickFlags[0] = 0;		  		// Pas d'objet choisis dans les evenements
	                rh4PickFlags[1] = 0;
	                rh4PickFlags[2] = 0;
	                rh4PickFlags[3] = 0;
	
	                // Si pas de OR dans le groupe
	                if ((evgPtr.evgFlags & CEventGroup.EVGFLAGS_ORINGROUP) == 0)
	                {
	                    rh2EventCount += 1;
	                    rh4ConditionsFalse = false;
	
	                    // Appel de la premiere routine
	                    count = 0;
	                    if ( (CCnd(evgPtr.evgEvents[count])).eva1(rhPtr, pHo) )
	                    {
	                        for (count++; count < evgPtr.evgNCond; count++)
	                        {
	                            if (( CCnd(evgPtr.evgEvents[count]) ).eva2(rhPtr) == false)
	                            {
	                                break;
	                            }
	                        }
	                    }
	
	                    // Appel des actions si le resultat est vrai
	                    // ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	                    if (count == evgPtr.evgNCond)
	                    {
	                        if (rh3DoStop)                             	// Groupe FAUX, mais faire event STOP?
	                        {
	                            // Appeler les actions STOP seulement?
	                            // ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	                            if (pHo != null)					// Seulement si un objet defini...
	                            {
	                                call_Stops(pHo);
	                            }
	                        }
	                        else
	                        {
	                            call_Actions(evgPtr);
	                        }
	                    }
	                    num++;
	                }
	                else
	                {
	                    rh4EventCountOR++;
	                    if ((evgPtr.evgFlags & CEventGroup.EVGFLAGS_ORLOGICAL) == 0)
	                    {
	                        bTrue = false;
	                        do
	                        {
	                            rh2EventCount++;
	                            rh4ConditionsFalse = false;
	                            count = eventPointersCnd[num];
	
	                            if (( CCnd(evgPtr.evgEvents[count]) ).eva1(rhPtr, pHo) == false)
	                            {
	                                rh4ConditionsFalse = true;
	                            }
	
	                            count++;
	                            while (count < evgPtr.evgNCond && evgPtr.evgEvents[count].evtCode != ((-24 << 16) | 65535))	 // CNDL_OR
	                            {
	                                if (( CCnd(evgPtr.evgEvents[count]) ).eva2(rhPtr) == false)
	                                {
	                                    rh4ConditionsFalse = true;
	                                }
	                                count++;
	                            }
	
	                            evt_MarkSelectedObjects();						// Stocke les objets
	                            if (rh4ConditionsFalse == false)
	                            {
	                                bTrue = true;
	                            }
	
	                            num++;
	                            evgPtr = eventPointersGroup[num];
	                            if (evgPtr == null)
	                            {
	                                break;
	                            }
	                        } while (evgPtr == rhEventGroup);
	
	                        if (bTrue)
	                        {
	                            rh2EventCount++;
	                            evt_BranchSelectedObjects();		// Branche tous les objets
	                            call_Actions(rhEventGroup);				// Appelle les actions
	                        }
	                    }
	                    else
	                    {
	                        var bFalse:Boolean;
	                        rh4ConditionsFalse = false;
	
	                        bTrue = false;
	                        do
	                        {
	                            rh2EventCount++;
	                            bFalse = false;
	                            count = eventPointersCnd[num];
	
	                            if (( CCnd(evgPtr.evgEvents[count]) ).eva1(rhPtr, pHo))
	                            {
	                                count++;
	                                while (count < evgPtr.evgNCond && evgPtr.evgEvents[count].evtCode != ((-25 << 16) | 65535))     // CNDL_ORLOGICAL
	                                {
	                                    if (( CCnd(evgPtr.evgEvents[count]) ).eva2(rhPtr) == false)
	                                    {
	                                        bFalse = true;
	                                        break;
	                                    }
	                                    count++;
	                                }
	                            }
	                            else
	                            {
	                                bFalse = true;
	                            }
	
	                            if (bFalse == false)
	                            {
	                                evt_MarkSelectedObjects();						// Stocke les objets
	                                bTrue = true;
	                            }
	
	                            num++;
	                            evgPtr = eventPointersGroup[num];
	                            if (evgPtr == null)
	                            {
	                                break;
	                            }
	
	                        } while (evgPtr == rhEventGroup);
	
	                        if (bTrue)
	                        {
	                            rh2EventCount++;
	                            evt_BranchSelectedObjects();		// Branche tous les objets
	                            call_Actions(rhEventGroup);				// Appelle les actions
	                        }
	                    }
	                }
	            }
	            else
	            {
	                // Si inactif, saute tous les groupes de condition
	                num++;
	                if (eventPointersGroup[num] != null)
	                {
	                    evgPtr2 = eventPointersGroup[num];
	                    while (evgPtr2 == evgPtr)
	                    {
	                        num++;
	                        if (eventPointersGroup[num] == null)
	                        {
	                            break;
	                        }
	                        evgPtr2 = eventPointersGroup[num];
	                    }
	                }
	            }
	        } while (eventPointersGroup[num] != null);
	    }

	    // ---------------------------------------------------------------------------
	    // EXECUTION DES ACTIONS
	    // ---------------------------------------------------------------------------
	    public function call_Actions(pEvg:CEventGroup):void
	    {
	        // Gestion des flags ONCE/NOT ALWAYS/REPEAT/NO MORE
	        // ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	        if ((pEvg.evgFlags & CEventGroup.EVGFLAGS_LIMITED) != 0)   				// Les actions limitees et validees
	        {
	            // Flag SHUFFLE
	            if ((pEvg.evgFlags & CEventGroup.EVGFLAGS_SHUFFLE) != 0)
	            {
	                rh2ShuffleBuffer = new CArrayList();
	            }
	
	            // Flag NOT ALWAYS
	            if ((pEvg.evgFlags & CEventGroup.EVGFLAGS_NOTALWAYS) != 0)
	            {
	                var w_cx:int = rhPtr.rhLoopCount;
	                var w_dx:int = pEvg.evgInhibit;
	                pEvg.evgInhibit = w_cx;
	                if (w_cx == w_dx)
	                {
	                    return;
	                }
	                w_cx -= 1;
	                if (w_cx == w_dx)
	                {
	                    return;
	                }
	            }
	
	            // Flag REPEAT
	            if ((pEvg.evgFlags & CEventGroup.EVGFLAGS_REPEAT) != 0)
	            {
	                if (pEvg.evgInhibitCpt != 0)		// sur?
	                {
	                    pEvg.evgInhibitCpt--;
	                }
	                else
	                {
	                    return;
	                }
	            }
	
	            // Flag NO MORE during
	            if ((pEvg.evgFlags & CEventGroup.EVGFLAGS_NOMORE) != 0)
	            {
	                var dwt:int = rhPtr.rhTimer / 10;		// Timer courant / 10
	                var dwmax:int;
	                if (pEvg.evgInhibitCpt >= 0)
	                {
	                    dwmax = pEvg.evgInhibitCpt;			// Timer maximum
	                }
	                else
	                {
	                    dwmax = 65536 - pEvg.evgInhibitCpt;
	                }
	                if (dwmax != 0 && dwt < dwmax)		// Pas encore pret!
	                {
	                    return;
	                }
	                pEvg.evgInhibitCpt = (dwt + pEvg.evgInhibit);		// Plus timer possible= timer maxi
	            }
	        }
	
	
	        // Premiere execution : toutes les actions
	        // ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	        rh2ActionCount++;				// Marqueur de boucle d'actions
	        rh2ActionLoop = false;				// Flag boucle
	        rh2ActionLoopCount = 0;                         // Numero de boucle d'actions
	        rh2ActionOn = true;			 	// On est dans les actions
	        var count:int = 0;                    		// Nombre d'actions
	        var actPtr:CAct;
	        do
	        {
	            actPtr = CAct(pEvg.evgEvents[count + pEvg.evgNCond]);
	            if ((actPtr.evtFlags & (CEvent.EVFLAGS_BADOBJECT | CEvent.EVFLAGS_DONEBEFOREFADEIN)) == 0)		// Une action BAD?
	            {
	                actPtr.execute(rhPtr);
	            }
	            count++;
	        } while (count < pEvg.evgNAct);
	
	        if (rh2ActionLoop)		// Encore des actions a faire?
	        {
	            // Deuxieme execution : juste les actions avec un flag
	            // ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	            do
	            {
	                rh2ActionLoop = false;				// Flag boucle
	                rh2ActionLoopCount++;                          // Numero de boucle
	                count = 0;
	                do
	                {
	                    actPtr = CAct( pEvg.evgEvents[count + pEvg.evgNCond]);
	                    if ((actPtr.evtFlags & CEvent.EVFLAGS_REPEAT) != 0)			// Action repeat?
	                    {
	                        actPtr.execute(rhPtr);
	                    }
	                    count++;
	                } while (count < pEvg.evgNAct);
	            } while (rh2ActionLoop);			// Encore des actions a faire?
	        }
	
	        // Appeler la routine de fin?
	        // ~~~~~~~~~~~~~~~~~~~~~~~~~~
	        rh2ActionOn = false;			 	// On est plus les actions
	        if (rh2ShuffleBuffer != null)
	        {
	            endShuffle();
	        }	
	    }

	    // ---------------------------------------------------------------------------
	    // EXECUTION UNIQUEMENT DES ACTIONS STOP ET BOUNCE POUR UN SEUL OBJET ESI
	    // ---------------------------------------------------------------------------
	    public function call_Stops(pHo:CObject):void
	    {
	        var oi:int;
	
	        // On ne traite qu'un seul objet!
	        // ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	        oi = pHo.hoOi;							// L'Oi en question
	        rh2EventCount += 1;                                             // des actions...
	        evt_AddCurrentObject(pHo);
	
	        // Premiere execution : toutes les actions STOP
	        // ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	        rh2ActionCount++;					// Marqueur de boucle d'actions
	        rh2ActionLoop = false;					// Flag boucle
	        rh2ActionLoopCount = 0;			// Numero de boucle d'actions
	        rh2ActionOn = true;					// On est dans les actions
	        var actPtr:CAct;
	        var count:int=0;
	        var num:int, numOi:int;
	        do
	        {
	            actPtr = CAct(rhEventGroup.evgEvents[rhEventGroup.evgNCond + count]);
	            num = actPtr.evtCode & 0xFFFF0000;
	            if (num == (4 << 16) || num == (9 << 16))       // ACTL_EXTSTOP - ACTL_EXTBOUNCE
	            {
	                if (oi == actPtr.evtOi)
	                {
	                    actPtr.execute(rhPtr);
	                }
	                else
	                {
	                    var oil:int = actPtr.evtOiList;			// Un qualifier?
	                    if ((oil & 0x8000) != 0)
	                    {
	                        var pq:CQualToOiList = qualToOiList[oil & 0x7FFF];
	                        numOi = 0;
	                        while (numOi < pq.qoiList.length)
	                        {
	                            if (pq.qoiList[numOi] == oi)
	                            {
	                                actPtr.execute(rhPtr);
	                                break;
	                            }
	                            numOi += 2;
	                        }
	                    }
	                }
	            }
	            count++;
	        } while (count < rhEventGroup.evgNAct);
	        rh2ActionOn = false;					// On est dans les actions
	    }

	    // Fin des actions shuffle : melange!
	    // ~~~~~~~~~~~~~~~~~~~~~~~~~~--------
	    public function endShuffle():void
	    {
	        if (rh2ShuffleBuffer.size() <= 1)
	        {
	            return;
	        }
	
	        var num1:int = rhPtr.random(rh2ShuffleBuffer.size());
	        var num2:int;
	        do
	        {
	            num2 = rhPtr.random(rh2ShuffleBuffer.size());
	        } while (num1 == num2);
	
	        var pHo1:CObject = CObject(rh2ShuffleBuffer.get(num1));
	        var pHo2:CObject = CObject(rh2ShuffleBuffer.get(num2));
	
	        // Echange les sprites
	        var x1:int = pHo1.hoX;
	        var y1:int = pHo1.hoY;
	        var x2:int = pHo2.hoX;
	        var y2:int = pHo2.hoY;
	        CRun.setXPosition(pHo1, x2);
	        CRun.setYPosition(pHo1, y2);
	        CRun.setXPosition(pHo2, x1);
	        CRun.setYPosition(pHo2, y1);
	        rh2ShuffleBuffer = null;
	    }

	    public function onMouseButton(b:int, nClicks:int):void
	    {
	        var mouse:int;
	
	        if (rhPtr == null)
	        {
	            return;
	        }
	        if (rhPtr.rh2PauseCompteur != 0)
	        {
	            return;
	        }
	        if (bReady == false)
	        {
	            return;
	        }
	
	        // Un evenement a traiter?
	        // -----------------------
	        mouse = b;
	        if (nClicks == 2)
	        {
	            mouse += PARAMCLICK_DOUBLE;
	        }
	
	        rhPtr.rh4TimeOut = 0;							// Plus de time-out!
	        if ((rhPtr.rhMouseUsed) != 0)
	        {
	            return;					// La souris est prise?
	        }
	        
	        // Genere les evenements dans le jeu
	        // ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	        rhCurParam0 = mouse;
	        rh2CurrentClick = mouse;			// Pour les evenements II
	        handle_GlobalEvents(((-5 << 16) | 0xFFFA));		// CNDL_MCLICK Evenement click normal
	        handle_GlobalEvents(((-6 << 16) | 0xFFFA));		// CNDL_MCLICKINZONE Evenement click sur une zone
	
	        // Explore les sprites en collision
	        // ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
			var count:int=0;
			var i:int;
			var pHox:CObject;
			var x1:int, y1:int, x2:int, y2:int;
			var list:CArrayList=new CArrayList();
			for (i=0; i<rhPtr.rhNObjects; i++)
			{
			    while(rhPtr.rhObjectList[count]==null)
					count++;
			    pHox=rhPtr.rhObjectList[count];
			    count++;

				x1=pHox.hoX-pHox.hoImgXSpot;
				y1=pHox.hoY-pHox.hoImgYSpot;
				x2=x1+pHox.hoImgWidth;
				y2=y1+pHox.hoImgHeight;
				if (rhPtr.rh2MouseX>=x1 && rhPtr.rh2MouseX<x2 && rhPtr.rh2MouseY>=y1 && rhPtr.rh2MouseY<y2)
				{
		            if ((pHox.hoFlags & CObject.HOF_DESTROYED) == 0)
		            {
						if (pHox.hoType==COI.OBJ_SPR)
						{
							if ((pHox.ros.rsFlags&CRSpr.RSFLAG_COLBOX)==0)
							{
								var image:CImage=rhPtr.rhApp.imageBank.getImageFromHandle(pHox.roc.rcImage);
								var mask:CMask=image.getMask(CMask.GCMF_OBSTACLE, pHox.roc.rcAngle, pHox.roc.rcScaleX, pHox.roc.rcScaleY);
								if (mask.testPoint(x1, y1, rhPtr.rh2MouseX, rhPtr.rh2MouseY))
								{
									list.add(pHox);								
								}
							}
							else
							{
								list.add(pHox);
							}
						}
						else
						{
							list.add(pHox);
						}
		            }
				}
			}
	        for (count = 0; count < list.size(); count++)
	        {
	            pHox = CObject(list.get(count));
                rhCurParam1 = pHox.hoOi;
                rh4_2ndObject = pHox;
                handle_GlobalEvents(((-7 << 16) | 0xFFFA));		// CNDL_MCLICKONOBJECT
	        }
	    }

	    public function onKeyDown(vk:int):void
	    {
	        if (rhPtr != null)
	        {
	            if (bReady == false)
	            {
	                return;
	            }
	
	            if (rhPtr.rh2PauseCompteur != 0)
	            {
	                if (rhPtr.rh4PauseKey == -1)
	                {
	                    rhPtr.resume();
	                    rhPtr.rh4EndOfPause = rhPtr.rhLoopCount;	    // Pour les evenements II
	                    handle_GlobalEvents(((-8 << 16) | 0xFFFD));	    // CNDL_ENDOFPAUSE
	                }
	                if (rhPtr.rh4PauseKey != 0 && rhPtr.rh4PauseKey == vk)
	                {
	                    rhPtr.resume();
	                    rhPtr.rh4EndOfPause = rhPtr.rhLoopCount;	    // Pour les evenements II
	                    handle_GlobalEvents(((-8 << 16) | 0xFFFD));	    // CNDL_ENDOFPAUSE
	                }
	                return;
	            }
	            rhPtr.rh4TimeOut = 0;				    // Plus de time-out!
	            handle_GlobalEvents(((-9 << 16) | 0xFFFA));		    // CNDL_ANYKEY
	        }
	    }

	    // MouseMove
	    public function onMouseMove():void
	    {
	        if (rhPtr != null)
	        {
	            if (bReady == false)
	            {
	                return;
	            }
	            if (rhPtr.rh2PauseCompteur != 0)
	            {
	                return;
	            }
	            rhPtr.rh4TimeOut = 0;
	        }
	    }

	    public function ctoCompare(pZone:PARAM_ZONE, pHo:CObject):Boolean
	    {
	        if (pHo.hoImgWidth == 0 || pHo.hoImgHeight == 0)
	        {
	            return false;
	        }
	        if (pHo.hoX < pZone.x1 || pHo.hoX >= pZone.x2)
	        {
	            return false;
	        }
	        if (pHo.hoY < pZone.y1 || pHo.hoY >= pZone.y2)
	        {
	            return false;
	        }
	        return true;
	    }

	    public function count_ZoneTypeObjects(pZone:PARAM_ZONE, stop:int, type:int):CObject
	    {
	        stop++;
	        evtNSelectedObjects = 0;
	
	        var oil:int = 0;
	        var poilLoop:CObjInfo = null;
	        var pHo:CObject;
	        var num:int;
	        do
	        {
	            for (; oil < rhPtr.rhOiList.length; oil++)
	            {
	                poilLoop = rhPtr.rhOiList[oil];
	                if (type == 0 || (type != 0 && type == poilLoop.oilType))
	                {
	                    break;
	                }
	            }
	            if (oil == rhPtr.rhOiList.length)
	            {
	                return null;
	            }
	
	            var poil:CObjInfo = poilLoop;
	            oil++;
	
	            if (poil.oilEventCount != rh2EventCount)
	            {
	                if (rh4ConditionsFalse == false)
	                {
	                    // Explore la liste entiere des objets
	                    num = poil.oilObject;
	                    while (num >= 0)
	                    {
	                        pHo = rhPtr.rhObjectList[num];
	                        if (pHo == null)
	                        {
	                            return null;
	                        }
	                        if ((pHo.hoFlags & CObject.HOF_DESTROYED) == 0)		// Deja detruit?
	                        {
	                            if (ctoCompare(pZone, pHo))
	                            {
	                                evtNSelectedObjects++;
	                                if (evtNSelectedObjects == stop)
	                                {
	                                    return pHo;
	                                }
	                            }
	                        }
	                        num = pHo.hoNumNext;
	                    }
	                }
	            }
	            else
	            {
	                // Explore la liste des objets selectionnes
	                num = poil.oilListSelected;
	                while (num >= 0)
	                {
	                    pHo = rhPtr.rhObjectList[num];
	                    if (pHo == null)
	                    {
	                        return null;
	                    }
	                    if ((pHo.hoFlags & CObject.HOF_DESTROYED) == 0)		// Deja detruit?
	                    {
	                        if (ctoCompare(pZone, pHo))
	                        {
	                            evtNSelectedObjects++;
	                            if (evtNSelectedObjects == stop)
	                            {
	                                return pHo;
	                            }
	                        }
	                    }
	                    num = pHo.hoNextSelected;
	                }
	            }
	        } while (true);
	        return null;
	    }

	    // ----------------------------------------
	    // Compte / Trouve des objets de type AX
	    // ----------------------------------------
	    public function count_ObjectsFromType(type:int, stop:int):CObject
	    {
	        stop++;									// BX a partir de 1!
	        evtNSelectedObjects = 0;
	
	        var oil:int = 0;
	        var poilLoop:CObjInfo = null;
	        var pHo:CObject;
	        var num:int;
	        
	        do
	        {
	            for (; oil < rhPtr.rhOiList.length; oil++)
	            {
	                poilLoop = rhPtr.rhOiList[oil];
	                if (type == 0 || (type != 0 && type == poilLoop.oilType))
	                {
	                    break;
	                }
	            }
	            if (oil == rhPtr.rhOiList.length)
	            {
	                return null;
	            }
	
	            var poil:CObjInfo = poilLoop;
	            oil++;
	
	            if (poil.oilEventCount != rh2EventCount)
	            {
	                if (rh4ConditionsFalse == false)
	                {
	                    // Explore la liste entiere des objets
	                    num = poil.oilObject;
	                    while (num >= 0)
	                    {
	                        pHo = rhPtr.rhObjectList[num];
	                        if (pHo == null)
	                        {
	                            return null;
	                        }
	                        if ((pHo.hoFlags & CObject.HOF_DESTROYED) == 0)		// Deja detruit?
	                        {
	                            evtNSelectedObjects++;
	                            if (evtNSelectedObjects == stop)
	                            {
	                                return pHo;
	                            }
	                        }
	                        num = pHo.hoNumNext;
	                    }
	                }
	            }
	            else
	            {
	                // Explore la liste des objets selectionnes
	                num = poil.oilListSelected;
	                while (num >= 0)
	                {
	                    pHo = rhPtr.rhObjectList[num];
	                    if (pHo == null)
	                    {
	                        return null;
	                    }
	                    if ((pHo.hoFlags & CObject.HOF_DESTROYED) == 0)		// Deja detruit?
	                    {
	                        evtNSelectedObjects++;
	                        if (evtNSelectedObjects == stop)
	                        {
	                            return pHo;
	                        }
	                    }
	                    num = pHo.hoNextSelected;
	                }
	            }
	        } while (true);
	        return null;
	    }

	    // Routine de test de la zone
	    // ~~~~~~~~~~~~~~~~~~~~~~~~~~
	    public function czaCompare(pZone:PARAM_ZONE, pHo:CObject ):Boolean
	    {
	        if (pHo.hoX < pZone.x1 || pHo.hoX >= pZone.x2)
	        {
	            return false;
	        }
	        if (pHo.hoY < pZone.y1 || pHo.hoY >= pZone.y2)
	        {
	            return false;
	        }
	        return true;
	    }

	    public function select_ZoneTypeObjects(p:PARAM_ZONE, type:int):int
	    {
	        var cpt:int = 0;
	
	        var oil:int = 0;
	        var poilLoop:CObjInfo  = null;
	        var pHoLoop:CObject, pHoFound:CObject;
	        var num:int;
	        do
	        {
	            for (; oil < rhPtr.rhOiList.length; oil++)
	            {
	                poilLoop = rhPtr.rhOiList[oil];
	                if (type == 0 || (type != 0 && type == poilLoop.oilType))
	                {
	                    break;
	                }
	            }
	            if (oil == rhPtr.rhOiList.length)
	            {
	                return cpt;
	            }
	
	            var poil:CObjInfo = poilLoop;
	            oil++;
	
	            if (poil.oilEventCount != rh2EventCount)
	            {
	                // Explore la liste entiere des objets, et branche les objets dans la zone
	                pHoLoop = null;
	                poil.oilNumOfSelected = 0;
	                poil.oilEventCount = rh2EventCount;
	                poil.oilListSelected = -1;
	                if (rh4ConditionsFalse == false)
	                {
	                    num = poil.oilObject;
	                    while (num >= 0)
	                    {
	                        pHoFound = rhPtr.rhObjectList[num];
	                        if (pHoFound == null)
	                        {
	                            break;
	                        }
	                        if ((pHoFound.hoFlags & CObject.HOF_DESTROYED) == 0)		// Deja detruit?
	                        {
	                            if (czaCompare(p, pHoFound))
	                            {
	                                cpt++;
	                                poil.oilNumOfSelected++;
	                                pHoFound.hoNextSelected = -1;
	                                if (pHoLoop == null)
	                                {
	                                    poil.oilListSelected = pHoFound.hoNumber;
	                                }
	                                else
	                                {
	                                    pHoLoop.hoNextSelected = pHoFound.hoNumber;
	                                }
	                                pHoLoop = pHoFound;
	                            }
	                        }
	                        num = pHoFound.hoNumNext;
	                    }
	                    ;
	                }
	                continue;
	            }
	
	            // Explore la liste des objets selectionnes, et vire les objets non dans la zone
	            pHoLoop = null;								// Pour le premier!
	            num = poil.oilListSelected;
	            while (num >= 0)
	            {
	                pHoFound = rhPtr.rhObjectList[num];
	                if (pHoFound == null)
	                {
	                    break;
	                }
	                if ((pHoFound.hoFlags & CObject.HOF_DESTROYED) == 0)			// Deja detruit?
	                {
	                    if (czaCompare(p, pHoFound) == false)
	                    {
	                        poil.oilNumOfSelected--;					// Un de moins!
	                        if (pHoLoop == null)
	                        {
	                            poil.oilListSelected = pHoFound.hoNextSelected;
	                        }
	                        else
	                        {
	                            pHoLoop.hoNextSelected = pHoFound.hoNextSelected;	//; oil.oilListSelected IDEM!
	                        }
	                    }
	                    else
	                    {
	                        cpt++;
	                        pHoLoop = pHoFound;
	                    }
	                }
	                num = pHoFound.hoNextSelected;
	            }
	            ;
	            continue;
	        } while (true);
	        return 0;
	    }

	    // ---------------------------------------------------
	    // Ligne de vue : selectionne les objets sur une ligne
	    // ---------------------------------------------------
	    public function losCompare(x1:Number, y1:Number, x2:Number, y2:Number, pHo:CObject):Boolean
	    {
	        var delta:Number;
	        var x:int, y:int;
	
	        var xLeft:int = pHo.hoX - pHo.hoImgXSpot;
	        var xRight:int = xLeft + pHo.hoImgWidth;
	        var yTop:int = pHo.hoY - pHo.hoImgYSpot;
	        var yBottom:int = yTop + pHo.hoImgHeight;
	
	        if (x2 - x1 > y2 - y1)
	        {
	            delta = (Number(y2 - y1)) / (Number(x2 - x1));
	            if (x2 > x1)
	            {
	                if (xRight < x1 || xLeft >= x2)
	                {
	                    return false;
	                }
	            }
	            else
	            {
	                if (xRight < x2 || xLeft >= x1)
	                {
	                    return false;
	                }
	            }
	            y = delta * (xLeft - x1) + y1;
	            if (y >= yTop && y < yBottom)
	            {
	                return true;
	            }
	
	            y = delta * (xRight - x1) + y1;
	            if (y >= yTop && y < yBottom)
	            {
	                return true;
	            }
	
	            return false;
	        }
	        else
	        {
	            delta = Number(x2 - x1) / Number(y2 - y1);
	            if (y2 > y1)
	            {
	                if (yBottom < y1 || yTop >= y2)
	                {
	                    return false;
	                }
	            }
	            else
	            {
	                if (yBottom < y2 || yTop >= y1)
	                {
	                    return false;
	                }
	            }
	            x = delta * (yTop - y1) + x1;
	            if (x >= xLeft && x < xRight)
	            {
	                return true;
	            }
	
	            x = delta * (yTop - y1) + x1;
	            if (x >= xLeft && x < xRight)
	            {
	                return true;
	            }
	
	            return false;
	        }
	    }

	    public function select_LineOfSight(x1:int, y1:int, x2:int, y2:int):int
	    {
	        var cpt:int = 0;
	
	        // Exploration de la liste des objets
	        var poil:CObjInfo;
	        var oil:int;
	        var pHoLoop:CObject, pHoFound:CObject;
	        var num:int;
	        for (oil = 0; oil < rhPtr.rhOiList.length; oil++)
	        {
	            poil = rhPtr.rhOiList[oil];
	            if (poil.oilEventCount != rh2EventCount)
	            {
	                // Explore la liste entiere des objets, et branche les objets dans la zone
	                pHoLoop = null;
	                poil.oilNumOfSelected = 0;
	                poil.oilEventCount = rh2EventCount;
	                poil.oilListSelected = -1;
	
	                // Si condition OR et conditions fausse, ne selectionne aucun objet
	                if (rh4ConditionsFalse == false)
	                {
	                    num = poil.oilObject;
	                    while (num >= 0)
	                    {
	                        pHoFound = rhPtr.rhObjectList[num];
	                        if (pHoFound == null)
	                        {
	                            break;
	                        }
	                        if ((pHoFound.hoFlags & CObject.HOF_DESTROYED) == 0)		// Deja detruit?
	                        {
	                            if (losCompare(x1, y1, x2, y2, pHoFound))
	                            {
	                                cpt++;
	                                poil.oilNumOfSelected++;
	                                pHoFound.hoNextSelected = -1;
	                                if (pHoLoop == null)
	                                {
	                                    poil.oilListSelected = pHoFound.hoNumber;
	                                }
	                                else
	                                {
	                                    pHoLoop.hoNextSelected = pHoFound.hoNumber;		//; Car idem oilListSelected!
	                                }
	                                pHoLoop = pHoFound;
	                            }
	                        }
	                        num = pHoFound.hoNumNext;
	                    }
	                }
	                continue;
	            }
	
	            // Explore la liste des objets selectionnes, et vire les objets non dans la zone
	            pHoLoop = null;								// Pour le premier!
	            num = poil.oilListSelected;
	            while (num >= 0)
	            {
	                pHoFound = rhPtr.rhObjectList[num];
	                if (pHoFound == null)
	                {
	                    break;
	                }
	                if ((pHoFound.hoFlags & CObject.HOF_DESTROYED) == 0)			// Deja detruit?
	                {
	                    if (losCompare(x1, y1, x2, y2, pHoFound) == false)
	                    {
	                        poil.oilNumOfSelected--;					// Un de moins!
	                        if (pHoLoop == null)
	                        {
	                            poil.oilListSelected = pHoFound.hoNextSelected;
	                        }
	                        else
	                        {
	                            pHoLoop.hoNextSelected = pHoFound.hoNextSelected;
	                        }
	                    }
	                    else
	                    {
	                        cpt++;
	                        pHoLoop = pHoFound;
	                    }
	                }
	                num = pHoFound.hoNextSelected;
	            }
	
	        }
	        return cpt;
	    }

	    // ----------------------------------------
	    // Compte / Trouve un objet dans une zone
	    // ----------------------------------------	
	    // Routine de comptage
	    public function czoCountThem(oil:int, pZone:PARAM_ZONE):int
	    {
	        var count:int = 0;
	        var poil:CObjInfo = rhPtr.rhOiList[oil];
	        var pHo:CObject;
	        var num:int;
	        
	        if (poil.oilEventCount != rh2EventCount)
	        {
	            if (rh4ConditionsFalse == false)
	            {
	                // Explore la liste entiere des objets
	                num = poil.oilObject;
	                while (num >= 0)
	                {
	                    pHo = rhPtr.rhObjectList[num];
	                    if (pHo == null)
	                    {
	                        return 0;
	                    }
	                    if ((pHo.hoFlags & CObject.HOF_DESTROYED) == 0)		// Deja detruit?
	                    {
	                        if (czaCompare(pZone, pHo))
	                        {
	                            count++;
	                        }
	                    }
	                    num = pHo.hoNumNext;
	                }
	            }
	            return count;
	        }
	
	        // Explore la liste des objets selectionnes
	        num = poil.oilListSelected;
	        while (num >= 0)
	        {
	            pHo = rhPtr.rhObjectList[num];
	            if (pHo == null)
	            {
	                return 0;
	            }
	            if ((pHo.hoFlags & CObject.HOF_DESTROYED) == 0)		// Deja detruit?
	            {
	                if (czaCompare(pZone, pHo))
	                {
	                    count++;
	                }
	            }
	            num = pHo.hoNextSelected;
	        }
	        return count;
	    }

	    public function count_ZoneOneObject(oil:int, pZone:PARAM_ZONE):int
	    {
	        // Un objet normal
	        if ((oil&0x8000)==0)
	        {
	            return czoCountThem(oil, pZone);
	        }
	
	        // Un qualifier
	        if ((oil&0x7FFF)==0x7FFF)
	        {
	            return 0;
	        }
	        var pqoi:CQualToOiList = qualToOiList[oil & 0x7FFF];
	        var qoi:int;
	        var count:int = 0;
	        for (qoi = 0; qoi < pqoi.qoiList.length; qoi += 2)
	        {
	            count += czoCountThem(pqoi.qoiList[qoi + 1], pZone);
	        }
	        return count;
	    }

	    // ----------------------------------------
	    // Compte / Trouve de objets definiss
	    // ----------------------------------------
	    // Routine de comptage
	    // ~~~~~~~~~~~~~~~~~~~
	    public function countThem(oil:int, stop:int):CObject
	    {
	        var poil:CObjInfo = rhPtr.rhOiList[oil];		// Pointe la liste
	        var pHo:CObject;
	        var num:int;
	        
	        if (poil.oilEventCount != rh2EventCount)
	        {
	            // Si condition OU
	            if (rh4ConditionsFalse)
	            {
	                evtNSelectedObjects = 0;
	                return null;
	            }
	
	            // Explore la liste entiere des objets
	            num = poil.oilObject;
	            while (num >= 0)
	            {
	                pHo = rhPtr.rhObjectList[num];
	                if (pHo == null)
	                {
	                    return null;
	                }
	                if ((pHo.hoFlags & CObject.HOF_DESTROYED) == 0)		// Deja detruit?
	                {
	                    evtNSelectedObjects++;
	                    if (evtNSelectedObjects == stop)
	                    {
	                        return pHo;
	                    }
	                }
	                num = pHo.hoNumNext;
	            }
	            return null;
	        }
	
	        // Explore la liste des objets selectionnes
	        num = poil.oilListSelected;
	        while (num >= 0)
	        {
	            pHo = rhPtr.rhObjectList[num];
	            if (pHo == null)
	            {
	                return null;
	            }
	            if ((pHo.hoFlags & CObject.HOF_DESTROYED) == 0)			// Deja detruit?
	            {
	                evtNSelectedObjects++;
	                if (evtNSelectedObjects == stop)
	                {
	                    return pHo;
	                }
	            }
	            num = pHo.hoNextSelected;
	        }
	        return null;
	    }

	    public function count_ObjectsFromOiList(oil:int, stop:int):CObject
	    {
	        stop++;									// BX a partir de 1!
	        evtNSelectedObjects = 0;
	        if ((oil&0x8000)==0)
	        {
	            // Un identifier normal
	            return countThem(oil, stop);
	        }
	
	        // Un qualifier
	        if ((oil&0x7FFF)==0x7FFF)
	        {
	            return null;
	        }
	        var pqoi:CQualToOiList = qualToOiList[oil & 0x7FFF];
	        var qoi:int;
	        for (qoi = 0; qoi < pqoi.qoiList.length; qoi += 2)
	        {
	            var pHo:CObject = countThem(pqoi.qoiList[qoi + 1], stop);
	            if (pHo != null)
	            {
	                return pHo;
	            }
	        }
	        return null;
	    }

	    // Pick un objet a partir de son fixed value
	    // -----------------------------------------
	    public function pickFromId(value:int):Boolean
	    {
	        var number:int = value & 0xFFFF;
	        if (number > rhPtr.rhMaxObjects)
	        {
	            return false;
	        }
	        var pHo:CObject = rhPtr.rhObjectList[number];
	        if (pHo == null)
	        {
	            return false;
	        }
	
	        var code:int = value >>> 16;
	        if (code != pHo.hoCreationId)
	        {
	            return false;
	        }
	
	        // Dans une liste selectionnee ou pas?
	        var poil:CObjInfo = pHo.hoOiList;
	        if (poil.oilEventCount == rh2EventCount)
	        {
	            var next:int = poil.oilListSelected;
	            var pHoFound:CObject = null;
	            while (next >= 0)
	            {
	                pHoFound = rhPtr.rhObjectList[next];
	                if (pHo == pHoFound)
	                {
	                    break;
	                }
	                next = pHoFound.hoNextSelected;
	            }
	            ;
	            if (pHo != pHoFound)
	            {
	                return false;
	            }
	        }
	        poil.oilEventCount = rh2EventCount;			// Seul sur la liste!
	        poil.oilListSelected = -1;
	        poil.oilNumOfSelected = 0;
	        pHo.hoNextSelected = -1;
	        evt_AddCurrentObject(pHo);
	        return true;
	    }

	    // ---------------------------------------------------------------------------
	    // Pousse un evenement pour la fin du cycle
	    // ---------------------------------------------------------------------------
	    public function push_Event(routine:int, code:int, lParam:int, pHo:CObject, oi:int):void
	    {
	        var p:CPushedEvent = new CPushedEvent(routine, code, lParam, pHo, oi);
	        if (rh2PushedEvents == null)
	        {
	            rh2PushedEvents = new CArrayList();
	        }
	        rh2PushedEvents.add(p);
	    }

	    // ---------------------------------------------------------------------------
	    // Traite tous les evenements pousse
	    // ---------------------------------------------------------------------------	
	    public function handle_PushedEvents():void
	    {
	        if (rh2PushedEvents != null)
	        {
	            var index:int;
	            for (index = 0; index < rh2PushedEvents.size(); index++)
	            {
	                var pEvt:CPushedEvent = CPushedEvent(rh2PushedEvents.get(index));
	                if (pEvt != null)
	                {
	                    if (pEvt.code != 0)
	                    {
	                        // Effectue l'un des evenements
	                        // ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	                        rhCurParam0 = pEvt.param;
	                        rhCurOi = pEvt.oi;
	                        switch (pEvt.routine)
	                        {
	                            case 0:
	                                handle_GlobalEvents(pEvt.code);
	                                break;
	                            case 1:
	                                handle_Event(pEvt.pHo, pEvt.code);
	                                break;
	                        }
	                    }
	                }
	            }
	            rh2PushedEvents.clear();
	        }
	    }

	    // --------------------------------------------------------------------------
	    // CHARGEMENT DES EVENEMENTS
	    // --------------------------------------------------------------------------
	    public function load(app:CRunApp):void
	    {
	        var code:Array = new Array(4);
	        var number:int;
	        var n:int;
	        var eventPos:int
	        while (true)
	        {
	            app.file.readBytesAsArray(code);
	
	            // EVTFILECHUNK_HEAD
	            if (code[0] == 0x45 && code[1] == 0x52 && code[2] == 0x3E && code[3] == 0x3E)
	            {
	                maxObjects = app.file.readAShort();
	                if (maxObjects < 300)
	                {
	                    maxObjects = 300;
	                }
	                maxOi = app.file.readAShort();
	                nPlayers = app.file.readAShort();
	                for (n = 0; n < 7 + COI.OBJ_LAST; n++)
	                {
	                    nConditions[n] = app.file.readAShort();
	                }
	                nQualifiers = app.file.readAShort();
	                if (nQualifiers > 0)
	                {
	                    qualifiers = new Array(nQualifiers);
	                    for (n = 0; n < nQualifiers; n++)
	                    {
	                        qualifiers[n] = new CLoadQualifiers();
	                        qualifiers[n].qOi = app.file.readShort();
	                        qualifiers[n].qType = app.file.readShort();
	                    }
	                }
	            }
	            // EVTFILECHUNK_EVTHEAD
	            else if (code[0] == 0x45 && code[1] == 0x52 && code[2] == 0x65 && code[3] == 0x73)
	            {
	                app.file.readAInt();
	                nEvents = app.file.readAInt();
	                events = new Array(nEvents);
	                eventPos = 0;
	            }
	            // EVTFILECHUNK_EVENTS
	            else if (code[0] == 0x45 && code[1] == 0x52 && code[2] == 0x65 && code[3] == 0x76)
	            {
	                app.file.readAInt();
	                number = app.file.readAInt();
	                for (n = 0; n < number; n++)
	                {
	                    events[eventPos] = CEventGroup.create(app);
	                    eventPos++;
	                }
	            }
	            // EVTFILECHUNK_END
	            else if (code[0] == 0x3C && code[1] == 0x3C && code[2] == 0x45 && code[3] == 0x52)
	            {
	                break;
	            }
	        }
	    }

	    // PREPARATION DU PROGRAMME POUR LE RUN
	
	    // Inactive tout un groupe et ses sous-groupes
	    public function inactiveGroup(evg:int):int
	    {
	        var bQuit:Boolean;
	        var evgPtr:CEventGroup;
	        var evtPtr:CEvent;
	        var grpPtr:PARAM_GROUP ;
	
	        evgPtr = events[evg];
	        evgPtr.evgFlags &= CEventGroup.EVGFLAGS_DEFAULTMASK;
	        evgPtr.evgFlags |= CEventGroup.EVGFLAGS_INACTIVE;
	
	        for (evg++  , bQuit=false;;)
	        {
	            evgPtr = events[evg];
	            evgPtr.evgFlags &= CEventGroup.EVGFLAGS_DEFAULTMASK;
	            evgPtr.evgFlags |= CEventGroup.EVGFLAGS_INACTIVE;
	
	            evtPtr = evgPtr.evgEvents[0];
	            switch (evtPtr.evtCode)
	            {
	                case ((-10 << 16) | 65535):		// CNDL_GROUP:
	                    grpPtr = PARAM_GROUP(evtPtr.evtParams[0]);
	                    grpPtr.grpFlags |= PARAM_GROUP.GRPFLAGS_PARENTINACTIVE;
	                    evg = inactiveGroup(evg);
	                    continue;
	                case ((-11 << 16) | 65535):		// CNDL_ENDGROUP:
	                    bQuit = true;
	                    evg++;
	                    break;
	            }
	            if (bQuit)
	            {
	                break;
	            }
	            evg++;
	        }
	        return evg;
	    }

	    public function prepareProgram():void
	    {
	        var evgPtr:CEventGroup;
	        var evtPtr:CEvent;
	        var grpPtr:PARAM_GROUP;
	        var evpPtr:CParam;
	        var evg:int, evt:int, evp:int;
	        var groups:CArrayList = new CArrayList();
	        var g:CGroupFind;
	        
	        // Nettoyage des flags groupe
	        for (evg = 0; evg < events.length;)
	        {
	            evgPtr = events[evg];
	            evgPtr.evgFlags &= CEventGroup.EVGFLAGS_DEFAULTMASK;
	
	            evtPtr = evgPtr.evgEvents[0];
	            if (evtPtr.evtCode == ((-10 << 16) | 65535))	// CNDL_GROUP)
	            {
	                grpPtr = PARAM_GROUP(evtPtr.evtParams[0]);
	                g = new CGroupFind();
	                g.id = grpPtr.grpId;
	                g.evg = evg;
	                groups.add(g);
	                grpPtr.grpFlags &= ~(PARAM_GROUP.GRPFLAGS_PARENTINACTIVE | PARAM_GROUP.GRPFLAGS_GROUPINACTIVE);
	
	                if ((grpPtr.grpFlags & PARAM_GROUP.GRPFLAGS_INACTIVE) != 0)
	                {
	                    grpPtr.grpFlags |= PARAM_GROUP.GRPFLAGS_GROUPINACTIVE;
	                }
	            }
	            evg++;
	        }
	
	        // Activation / desactivation des groupes
	        for (evg = 0; evg < events.length;)
	        {
	            evgPtr = events[evg];
	            evgPtr.evgFlags &= CEventGroup.EVGFLAGS_DEFAULTMASK;
	
	            evtPtr = evgPtr.evgEvents[0];
	            if (evtPtr.evtCode == ((-10 << 16) | 65535))	// CNDL_GROUP
	            {
	                grpPtr = PARAM_GROUP(evtPtr.evtParams[0]);
	                grpPtr.grpFlags &= ~PARAM_GROUP.GRPFLAGS_PARENTINACTIVE;
	
	                // Groupe entier inactif?
	                if ((grpPtr.grpFlags & PARAM_GROUP.GRPFLAGS_GROUPINACTIVE) != 0)
	                {
	                    evg = inactiveGroup(evg);
	                    continue;
	                }	
	            }
	            evg++;
	        }
	
	        // Mise a zero des flags evenements
	        for (evg = 0; evg < events.length; evg++)
	        {
	            evgPtr = events[evg];
	            evtPtr = evgPtr.evgEvents[0];
	            switch (evtPtr.evtCode)
	            {
	                case ((-10 << 16) | 65535):	    // CNDL_GROUP
	                case ((-11 << 16) | 65535):	    // CNDL_ENDGROUP
	                    break;
	
	                default:
	                    evgPtr.evgInhibit = 0;
	                    evgPtr.evgInhibitCpt = 0;
	                    for (evt = 0; evt < evgPtr.evgNCond + evgPtr.evgNAct; evt++)
	                    {
	                        evtPtr = evgPtr.evgEvents[evt];
	                        // RAZ des flags conditions / actions
	                        // ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	                        if (evtPtr.evtCode < 0)
	                        {
	                            evtPtr.evtFlags &= CEvent.EVFLAGS_DEFAULTMASK;
	                        }
	                        else
	                        {
	                            evtPtr.evtFlags &= ~(CAct.ACTFLAGS_REPEAT | CEvent.EVFLAGS_NOTDONEINSTART);
	                        }
	
	                        // RAZ des parametres speciaux
	                        // ~~~~~~~~~~~~~~~~~~~~~~~~~~~
	                        if (evtPtr.evtNParams != 0)
	                        {
	                            for (evp = 0; evp < evtPtr.evtNParams; evp++)
	                            {
	                                evpPtr = evtPtr.evtParams[evp];
	                                switch (evpPtr.code)
	                                {
	                                    case 13:	    // PARAM_EVERY
	                                        var p:PARAM_EVERY = PARAM_EVERY(evpPtr);
	                                        p.compteur = p.delay;
	                                        break;
	                                    case 39:	    // PARAM_GROUPOINTER
	                                        var gp:PARAM_GROUPOINTER = PARAM_GROUPOINTER(evpPtr);
	                                        var n:int;
	                                        for (n = 0; n < groups.size(); n++)
	                                        {
	                                            g = CGroupFind(groups.get(n));
	                                            if (g.id == gp.id)
	                                            {
	                                                gp.pointer = g.evg;
	                                                break;
	                                            }
	                                        }
	                                        break;
	                                }
	                            }
	                        }
	                    }
	                    break;
	            }
	        }
	    }

	    // ASSEMBLE LE PROGRAMME : BRANCHE LES POINTEURS DANS CHAQUE OBJET , OPTIMISE ET TOUT
	    public function assemblePrograms(run:CRun):void
	    {
	        var evgPtr:CEventGroup;
	        var evtPtr:CEvent;
	        var evpPtr:CParam;
	
	        var o:int, oo:int;
	        var oi:int, oi1:int, oi2:int;
	        var type:int;
	        var nOi:int, i:int, n:int, num:int, type1:int, type2:int;
	        var d:int, evgF:int, evgM:int, q:int, d1:int, d2:int;
	        var code:int;
	        var fWrap:int;
	        var evtAlways:int, evtAlwaysPos:int;
	        var aTimers:int, ss:int;
	        var bOrBefore:Boolean;
	        var cndOR:int;
	        var oilPtr:CObjInfo;
	        var hoPtr:CObject;
	
	        rhPtr = run;
	
	        rh2ActionCount = 0;  				// Force le compte des actions a 0
	
	        // Nettoie la curFrame.m_oiList : enleve les blancs, compte les objets
	        var oiMax:int = 0;
	        for (nOi = 0  , n=0; n < rhPtr.rhMaxOI; n++)
	        {
	            if (rhPtr.rhOiList[n].oilOi != -1)
	            {
	                rhPtr.rhOiList[n].oilActionCount = -1;
	                rhPtr.rhOiList[n].oilLimitFlags = 0;
	                rhPtr.rhOiList[n].oilLimitList = -1;
	                nOi++;
	                if (rhPtr.rhOiList[n].oilOi + 1 > oiMax)
	                {
	                    oiMax = rhPtr.rhOiList[n].oilOi + 1;
	                }
	            }
	        }
	
	        // Fabrique la liste des oi pour chaque qualifier
	        qualToOiList = null;
	        var oil:int;
	        if (nQualifiers > 0)
	        {
	            var count:Array=new Array(nQualifiers);
	            for (q = 0; q < nQualifiers; q++)
	            {
	                oi = (qualifiers[q].qOi) & 0x7FFF;
	                count[q] = 0;
	                for (oil = 0; oil < rhPtr.rhMaxOI; oil++)
	                {
	                    if (rhPtr.rhOiList[oil].oilType == qualifiers[q].qType)
	                    {
	                        for (n = 0; n < 8 && rhPtr.rhOiList[oil].oilQualifiers[n] != -1; n++)      // MAX_QUALIFIERS
	                        {
	                            if (oi == rhPtr.rhOiList[oil].oilQualifiers[n])
	                            {
	                                count[q]++;
	                            }
	                        }
	                    }
	                }
	            }
	
	            qualToOiList = new Array(nQualifiers);
	            for (q = 0; q < nQualifiers; q++)
	            {
	                qualToOiList[q] = new CQualToOiList();
	
	                if (count[q] != 0)
	                {
	                    qualToOiList[q].qoiList = new Array(count[q] * 2);
	                }
	
	                i = 0;
	                oi = (qualifiers[q].qOi) & 0x7FFF;
	                for (oil = 0; oil < rhPtr.rhMaxOI; oil++)
	                {
	                    if (rhPtr.rhOiList[oil].oilType == qualifiers[q].qType)
	                    {
	                        for (n = 0; n < 8 && rhPtr.rhOiList[oil].oilQualifiers[n] != -1; n++)
	                        {
	                            if (oi == rhPtr.rhOiList[oil].oilQualifiers[n])
	                            {
	                                qualToOiList[q].qoiList[i * 2] = rhPtr.rhOiList[oil].oilOi;
	                                qualToOiList[q].qoiList[i * 2 + 1] = oil;
	                                i++;
	                            }
	                        }
	                    }
	                }
	                qualToOiList[q].qoiActionCount = -1;
	            }
	        }
	
	        // Poke les offsets des oi dans le programme, prepare les parametres / cree les tables de limitations
	        // Marque les evenements a traiter dans la boucle
	        // --------------------------------------------------------------------------------------------------
	
	        // 100 actions STOP par objet... 	// YVES: nOi -> nOi+1 pour eviter erreurs si pas d'objet actif
	        colBuffer = new Array(oiMax * 100 * 2 + 1);
	        var colList:int = 0;
	
	        // Boucle d'exploration du programme
	        var evg:int, evt:int, evp:int;
	        for (evg = 0; evg < events.length; evg++)
	        {
	            evgPtr = events[evg];
	
	            // Initialisation des parametres / pointeurs sur oilists/qoioilist
	            // -------------------------------------------------------------
	            for (evt = 0; evt < evgPtr.evgNAct + evgPtr.evgNCond; evt++)
	            {
	                evtPtr = evgPtr.evgEvents[evt];
	
	                // Pas de flag BAD
	                evtPtr.evtFlags &= ~CEvent.EVFLAGS_BADOBJECT;
	
	                // Si evenement pour un objet reel, met l'adresse de l'curFrame.m_oiList
	                // ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	                if (EVTTYPE(evtPtr.evtCode) >= 0)
	                {
	                    evtPtr.evtOiList = get_OiListOffset(evtPtr.evtOi, EVTTYPE(evtPtr.evtCode));
	                }
	
	                // Exploration des parametres
	                // ~~~~~~~~~~~~~~~~~~~~~~~~~~
	                if (evtPtr.evtNParams > 0)
	                {
	                    for (evp = 0; evp < evtPtr.evtNParams; evp++)
	                    {
	                        evpPtr = evtPtr.evtParams[evp];
	                        switch (evpPtr.code)
	                        {
	                            // Met un parametre buffer 4 a zero
	                            case 25:        // PARAM_BUFFER4:
	                                (PARAM_INT(evpPtr)).value = 0;
	                                break;
	
	                            // Trouve le levobj de creation
	                            case 21:        // PARAM_SYSCREATE:
	                                if ((evtPtr.evtOi & COI.OIFLAG_QUALIFIER) == 0)
	                                {
	                                    var loPtr:CLO;
	                                    for (loPtr = rhPtr.rhFrame.LOList.first_LevObj(); loPtr != null; loPtr = rhPtr.rhFrame.LOList.next_LevObj())
	                                    {
	                                        if (evtPtr.evtOi == loPtr.loOiHandle)
	                                        {
	                                            (CCreate(evpPtr)).cdpHFII = loPtr.loHandle;
	                                            break;
	                                        }
	                                    }
	                                }
	                                else
	                                {
	                                    (CCreate(evpPtr)).cdpHFII = -1;
	                                }
	                                oi = (CPosition(evpPtr)).posOINUMParent;
	                                if (oi != -1)
	                                {
	                                    (CPosition(evpPtr)).posOiList = get_OiListOffset(oi, (CPosition(evpPtr)).posTypeParent);
	                                }
	                                break;
	                                
	                            // Met l'adresse du levObj pour create object
	                            case 9:         // PARAM_CREATE:
	                            case 18:        // PARAM_SHOOT:
	                            case 16:        // PARAM_POSITION:
	                                oi = (CPosition(evpPtr)).posOINUMParent;
	                                if (oi != -1)
	                                {
	                                    (CPosition(evpPtr)).posOiList = get_OiListOffset(oi, (CPosition(evpPtr)).posTypeParent);
	                                }
	                                break;
	
	                            // Poke l'adresse de l'objet dans l'curFrame.m_oiList
	                            case 1:         // PARAM_OBJECT:
	                                (PARAM_OBJECT(evpPtr)).oiList = get_OiListOffset((PARAM_OBJECT(evpPtr)).oi, (PARAM_OBJECT(evpPtr)).type);
	                                break;
	
	                            // Expression : poke l'adresse de l'curFrame.m_oiList dans les parametres objets
	                            case 15:        // PARAM_SPEED:
	                            case 27:        // PARAM_SAMLOOP:
	                            case 28:        // PARAM_MUSLOOP:
	                            case 45:        // PARAM_EXPSTRING:
	                            case 46:        // PARAM_CMPSTRING:
	                            case 22:        // PARAM_EXPRESSION:
	                            case 23:        // PARAM_COMPARAISON:
	                            case 52:        // PARAM_VARGLOBAL_EXP:
	                            case 59:        // PARAM_STRINGGLOBAL_EXP:
	                            case 53:        // PARAM_ALTVALUE_EXP:
	                            case 54:        // PARAM_FLAG_EXP:
	                                var expPtr:CParamExpression = CParamExpression(evpPtr);
	                                for (n = 0; n < expPtr.tokens.length; n++)
	                                {
	                                    // Un objet avec OI?
	                                    if (EVTTYPE(expPtr.tokens[n].code) > 0)
	                                    {
	                                        var expOi:CExpOi = CExpOi(expPtr.tokens[n]);
	                                        expOi.oiList = get_OiListOffset(expOi.oi, EVTTYPE(expOi.code));
	                                    }
	                                }
	                                ;
	                                break;
	                        }
	                    }
	                }
	            }
	
	            // Flags par defaut / Listes de limitation
	            // ---------------------------------------
	            evgF = 0;
	            evgM = CEventGroup.EVGFLAGS_ONCE | CEventGroup.EVGFLAGS_LIMITED | CEventGroup.EVGFLAGS_STOPINGROUP;
	            for (evt = 0; evt < evgPtr.evgNCond + evgPtr.evgNAct; evt++)
	            {
	                evtPtr = evgPtr.evgEvents[evt];
	
	                type = EVTTYPE(evtPtr.evtCode);
	                code = evtPtr.evtCode;
	                n = 0;
	                d1 = 0;
	                d2 = 0;
	                evpPtr = null;
	                if (type >= COI.OBJ_SPR)
	                {
	                    switch (getEventCode(code))
	                    {
	                        case (4 << 16):      // ACTL_EXTSTOP:
	                        case (9 << 16):      // ACTL_EXTBOUNCE:
	
	                            evgF |= CEventGroup.EVGFLAGS_STOPINGROUP;
	
	                            // Recherche dans le groupe, la cause du STOP-> limitList
	                            // ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	                            oi = evtPtr.evtOi;
	                            if ((oi & COI.OIFLAG_QUALIFIER) != 0)
	                            {
	                                for (o = qual_GetFirstOiList2(evtPtr.evtOiList); o != -1; o = qual_GetNextOiList2())
	                                {
	                                    colList = make_ColList1(evgPtr, colList, rhPtr.rhOiList[o].oilOi);
	                                }
	                            }
	                            else
	                            {
	                                colList = make_ColList1(evgPtr, colList, oi);
	                            }
	                            break;
	                        case (25 << 16):      // ACTL_EXTSHUFFLE:
	                            evgF |= CEventGroup.EVGFLAGS_SHUFFLE;
	                            break;
	                        case (-14 << 16):     // CNDL_EXTCOLLISION:
								evpPtr = evtPtr.evtParams[0];								
								var pEvpObject:PARAM_OBJECT=PARAM_OBJECT(evtPtr.evtParams[0]);
								addColList(evtPtr.evtOiList, evtPtr.evtOi, pEvpObject.oiList, pEvpObject.oi);
								addColList(pEvpObject.oiList, pEvpObject.oi, evtPtr.evtOiList, evtPtr.evtOi);
								// L'objet 1 est-il un sprite?
								type1= EVTTYPE(evtPtr.evtCode);
								if (isTypeRealSprite(type1))
								{
									d2 = CObjInfo.OILIMITFLAGS_QUICKCOL | CObjInfo.OILIMITFLAGS_ONCOLLIDE;
								}
								else
								{
									d2 = CObjInfo.OILIMITFLAGS_QUICKCOL | CObjInfo.OILIMITFLAGS_QUICKEXT | CObjInfo.OILIMITFLAGS_ONCOLLIDE;
								}
								
								// L'objet 2 est-il un sprite?
								type2=pEvpObject.type;
								if (isTypeRealSprite(type2))
								{
									d1 = CObjInfo.OILIMITFLAGS_QUICKCOL | CObjInfo.OILIMITFLAGS_ONCOLLIDE;
								}
								else
								{
									d1 = CObjInfo.OILIMITFLAGS_QUICKCOL | CObjInfo.OILIMITFLAGS_QUICKEXT | CObjInfo.OILIMITFLAGS_ONCOLLIDE;
								}
								n = 3;
								break;
	                        case (-4 << 16):     // CNDL_EXTISCOLLIDING:
	                            // L'objet 1 est-il un sprite?
	                            type1= EVTTYPE(evtPtr.evtCode);
	                            if (isTypeRealSprite(type1))
	                            {
	                                d2 = CObjInfo.OILIMITFLAGS_QUICKCOL;
	                            }
	                            else
	                            {
	                                d2 = CObjInfo.OILIMITFLAGS_QUICKCOL | CObjInfo.OILIMITFLAGS_QUICKEXT;
	                            }
	
	                            // L'objet 2 est-il un sprite?
	                            evpPtr = evtPtr.evtParams[0];
	                            type2= ( PARAM_OBJECT(evtPtr.evtParams[0]) ).type;
	                            if (isTypeRealSprite(type2))
	                            {
	                                d1 = CObjInfo.OILIMITFLAGS_QUICKCOL;
	                            }
	                            else
	                            {
	                                d1 = CObjInfo.OILIMITFLAGS_QUICKCOL | CObjInfo.OILIMITFLAGS_QUICKEXT;
	                            }
	                            n = 3;
	                            break;
	                        case (-11 << 16):     // CNDL_EXTINPLAYFIELD:
	                        case (-12 << 16):     // CNDL_EXTOUTPLAYFIELD:
	                            d1 = CObjInfo.OILIMITFLAGS_QUICKBORDER;
	                            n = 1;
	                            break;
	                        case (-13 << 16):     // CNDL_EXTCOLBACK:
	                            d1 = CObjInfo.OILIMITFLAGS_QUICKBACK;
	                            n = 1;
	                            break;
	                    }
	                }
	                else
	                {
	                    switch (code)
	                    {
	                        case ((-6 << 16) | 65535):      // CNDL_ONCE
	                            evgM &= ~CEventGroup.EVGFLAGS_ONCE;
	                            break;
	                        case ((-7 << 16) | 65535):      // CNDL_NOTALWAYS:
	                            evgM |= CEventGroup.EVGFLAGS_NOMORE;
	                            break;
	                        case ((-5 << 16) | 65535):      // CNDL_REPEAT:
	                            evgM |= CEventGroup.EVGFLAGS_NOMORE;
	                            break;
	                        case ((-4 << 16) | 65535):      // CNDL_NOMORE:
	                            evgM |= CEventGroup.EVGFLAGS_NOTALWAYS + CEventGroup.EVGFLAGS_REPEAT;
	                            break;
	                        case ((-4 << 16) | 0xFFFA):     // CNDL_MONOBJECT:
	                            d2 = CObjInfo.OILIMITFLAGS_QUICKCOL;
	                            evpPtr = evtPtr.evtParams[0];
	                            n = 2;
	                            break;
	                        case ((-7 << 16) | 0xFFFA):     // CNDL_MCLICKONOBJECT:
	                            d2 = CObjInfo.OILIMITFLAGS_QUICKCOL;
	                            evpPtr = evtPtr.evtParams[1];
	                            n = 2;
	                            break;
	                    }
	                }
	                // Poke les flags collision
	                if ((n & 1) != 0)
	                {
	                    for (o = qual_GetFirstOiList(evtPtr.evtOiList); o != -1; o = qual_GetNextOiList())
	                    {
	                        rhPtr.rhOiList[o].oilLimitFlags |= d1;
	                    }
	                }
	                if ((n & 2) != 0)
	                {
	                    for (o = qual_GetFirstOiList(( PARAM_OBJECT(evpPtr) ).oiList); o != -1; o = qual_GetNextOiList())
	                    {
	                        rhPtr.rhOiList[o].oilLimitFlags |= d2;
	                    }
	                }
	            }
	            // Inhibe les anciens flags
	            evgPtr.evgFlags &= ~evgM;
	            evgPtr.evgFlags |= evgF;
	        }
	        colBuffer[colList] = -1;
	
	        // Reserve le buffer des pointeurs sur listes d'events
	        // ---------------------------------------------------
	        var aListPointers:Array = new Array(COI.NUMBEROF_SYSTEMTYPES + oiMax + 1);
	
	        // Rempli cette table avec les offsets en fonction des types
	        ss = 0;
	        var alp:int;
	        for (alp = 0  , type = -COI.NUMBEROF_SYSTEMTYPES; type<0; type++, alp++)
	        {
	            aListPointers[alp] = ss;
	            ss += nConditions[COI.NUMBEROF_SYSTEMTYPES + type];
	        }
	        // Continue avec les OI, la taille juste pour le type de l'oi
	        for (oil = 0; oil < rhPtr.rhMaxOI; oil++, alp++)
	        {
	            aListPointers[alp] = ss;
	            if (rhPtr.rhOiList[oil].oilType < COI.KPX_BASE)
	            {
	                ss += nConditions[COI.NUMBEROF_SYSTEMTYPES + rhPtr.rhOiList[oil].oilType] + EVENTS_EXTBASE + 1;
	            }
	            else
	            {
					ss += rhPtr.rhApp.extLoader.getNumberOfConditions(rhPtr.rhOiList[oil].oilType) + EVENTS_EXTBASE + 1;
	            }
	        }
	
	        // Reserve le buffer des pointeurs
	        var sListPointers:int = ss;
	        listPointers = new Array(sListPointers);
	        for (n = 0; n < sListPointers; n++)
	        {
	            listPointers[n] = 0;
	        }
	        evtAlways = 0;
	
	        // Explore le programme et repere les evenements
	        var wBufNear:Array = new Array(rhPtr.rhFrame.maxObjects);
	        var wPtrNear:int;
	        for (evg = 0; evg < nEvents; evg++)
	        {
	            evgPtr = events[evg];
	            evgPtr.evgFlags &= ~CEventGroup.EVGFLAGS_ORINGROUP;
	            bOrBefore = true;
	            cndOR = 0;
	            for (evt = 0; evt < evgPtr.evgNCond; evt++)
	            {
	                evtPtr = evgPtr.evgEvents[evt];
	                type = EVTTYPE(evtPtr.evtCode);
	                code = evtPtr.evtCode;
	                num = -EVTNUM(code);
	
	                if (bOrBefore)
	                {
	                    // Dans la liste des evenements ALWAYS
	                    if ((evtPtr.evtFlags & CEvent.EVFLAGS_ALWAYS) != 0)
	                    {
	                        evtAlways++;
	                    }
	
	                    // Dans la liste des evenements generaux si objet systeme
	                    if (type < 0)
	                    {
	                        listPointers[aListPointers[7 + type] + num]++;
	                    }
	                    else
	                    // Un objet normal / qualifier : relie aux objets
	                    {
	                        wPtrNear = 0;
	                        for (o = qual_GetFirstOiList(evtPtr.evtOiList); o != -1; o = qual_GetNextOiList())
	                        {
	                            listPointers[aListPointers[COI.NUMBEROF_SYSTEMTYPES + o] + num]++;
	                            wBufNear[wPtrNear++] = o;
	                        }
	                        wBufNear[wPtrNear] = -1;
	                        // Cas special pour les collisions de sprites : branche aux deux sprites (sauf si meme!)
	                        if (getEventCode(code) == (-14 << 16))      // CNDL_EXTCOLLISION
	                        {
	                            evpPtr = evtPtr.evtParams[0];
	                            for (oo = qual_GetFirstOiList((PARAM_OBJECT(evpPtr)).oiList); oo != -1; oo = qual_GetNextOiList())
	                            {
	                                for (wPtrNear = 0; wBufNear[wPtrNear] != oo && wBufNear[wPtrNear] != -1; wPtrNear++)
										;
	                                if (wBufNear[wPtrNear] == -1)
	                                {
	                                    listPointers[aListPointers[COI.NUMBEROF_SYSTEMTYPES + oo] + num]++;
	                                }
	                            }
	                        }
	                    }
	                }
	                bOrBefore = false;
	                if (evtPtr.evtCode == ((-24 << 16) | 65535) || evtPtr.evtCode == ((-25 << 16) | 65535))     // CNDL_OR - CNDL_ORLOGICAL
	                {
	                    bOrBefore = true;
	                    evgPtr.evgFlags |= CEventGroup.EVGFLAGS_ORINGROUP;
	                    // Un seul type de OR dans un groupe
	                    if (cndOR == 0)
	                    {
	                        cndOR = evtPtr.evtCode;
	                    }
	                    else
	                    {
	                        evtPtr.evtCode = cndOR;
	                    }
	                    // Marque les OR Logical
	                    if (cndOR == ((-25 << 16) | 65535))       // CNDL_ORLOGICAL)
	                    {
	                        evgPtr.evgFlags |= CEventGroup.EVGFLAGS_ORLOGICAL;
	                    }
	                }
	            }
	        }
	
	        // Calcule les tailles necessaires, poke les pointeurs dans les listes
	        // ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	        var sEventPointers:int = evtAlways + 1;
	        var uil:int;
	        for (uil = 0; uil < sListPointers; uil++)
	        {
	            if (listPointers[uil] != 0)
	            {
	                ss = listPointers[uil];
	                listPointers[uil] = sEventPointers;
	                sEventPointers += ss + 1;
	            }
	        }
	        eventPointersGroup = new Array(sEventPointers);
	        eventPointersCnd = new Array(sEventPointers);
	        for (n = 0; n < sEventPointers; n++)
	        {
	            eventPointersGroup[n] = null;
	            eventPointersCnd[n] = 0;
	        }
	
	        var lposBuffer:Array = new Array(sListPointers);
	        for (n = 0; n < sListPointers; n++)
	        {
	            lposBuffer[n] = listPointers[n];
	        }
	
	        evtAlwaysPos = 0;
	        evtAlways = 0;
	        var lposPtr:int;
	        for (evg = 0; evg < nEvents; evg++)
	        {
	            evgPtr = events[evg];
	            bOrBefore = true;
	            for (evt = 0; evt < evgPtr.evgNCond; evt++)
	            {
	                evtPtr = evgPtr.evgEvents[evt];
	                type = EVTTYPE(evtPtr.evtCode);
	                code = evtPtr.evtCode;
	                num = -EVTNUM(code);
	
	                if (bOrBefore)
	                {
	                    // Dans la liste des evenements ALWAYS
	                    if ((evtPtr.evtFlags & CEvent.EVFLAGS_ALWAYS) != 0)
	                    {
	                        evtAlways++;
	                        eventPointersGroup[evtAlwaysPos] = evgPtr;
	                        eventPointersCnd[evtAlwaysPos] = evt;
	                        evtAlwaysPos++;
	                    }
	
	                    // Dans la liste des evenements generaux si objet systeme
	                    if (type < 0)
	                    {
	                        lposPtr = aListPointers[COI.NUMBEROF_SYSTEMTYPES + type] + num;
	                        eventPointersGroup[lposBuffer[lposPtr]] = evgPtr;
	                        eventPointersCnd[lposBuffer[lposPtr]] = evt;
	                        lposBuffer[lposPtr]++;
	                    }
	                    else
	                    // Un objet normal : relie a l'objet
	                    {
	                        wPtrNear = 0;
	                        for (o = qual_GetFirstOiList(evtPtr.evtOiList); o != -1; o = qual_GetNextOiList())
	                        {
	                            lposPtr = aListPointers[COI.NUMBEROF_SYSTEMTYPES + o] + num;
	                            eventPointersGroup[lposBuffer[lposPtr]] = evgPtr;
	                            eventPointersCnd[lposBuffer[lposPtr]] = evt;
	                            lposBuffer[lposPtr]++;
	                            wBufNear[wPtrNear++] = o;
	                        }
	                        wBufNear[wPtrNear] = -1;
	                        // Cas special pour les collisions de sprites : branche aux deux sprites (sauf si meme!)
	                        if (getEventCode(code) == (-14 << 16))      // CNDL_EXTCOLLISION
	                        {
	                            evpPtr = evtPtr.evtParams[0];
	                            for (oo = qual_GetFirstOiList(( PARAM_OBJECT(evpPtr) ).oiList); oo != -1; oo = qual_GetNextOiList())
	                            {
	                                for (wPtrNear = 0; wBufNear[wPtrNear] != oo && wBufNear[wPtrNear] != -1; wPtrNear++)
										;
	                                if (wBufNear[wPtrNear] == -1)
	                                {
	                                    lposPtr = aListPointers[COI.NUMBEROF_SYSTEMTYPES + oo] + num;
	                                    eventPointersGroup[lposBuffer[lposPtr]] = evgPtr;
	                                    eventPointersCnd[lposBuffer[lposPtr]] = evt;
	                                    lposBuffer[lposPtr]++;
	                                }
	                            }
	                        }
	                    }
	                }
	                bOrBefore = false;
	                if (evtPtr.evtCode == ((-24 << 16) | 65535) || evtPtr.evtCode == ((-25 << 16) | 65535))     // CNDL_OR - CNDL_ORLOGICAL
	                {
	                    bOrBefore = true;
	                }
	            }
	        }
	        ;
	
	        // Adresse des conditions timer
	        // ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	        uil = aListPointers[COI.NUMBEROF_SYSTEMTYPES + COI.OBJ_TIMER];
	        aTimers = listPointers[uil - EVTNUM(((-3 << 16) | 0xFFFC))];     // CNDL_TIMER
	
	        // Poke les adresses et les autres flags des pointeurs dans tous OI
	        // ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	        limitBuffer = new Array(oiMax + 1 + colList / 2);
	        var limitListStart:int = 0;
	        var limitPos:int, limitCur:int;
	        for (oil = 0; oil < rhPtr.rhMaxOI; oil++)
	        {
	            oilPtr = rhPtr.rhOiList[oil];
	
	            // Poke l'offset dans les events
	            // ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	            uil = aListPointers[COI.NUMBEROF_SYSTEMTYPES + oil];
	            oilPtr.oilEvents = uil;
	
	            // Traitement des flags particuliers
	            // ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	            var act:int;
	            if ((oilPtr.oilOEFlags & CObjectCommon.OEFLAG_MOVEMENTS) != 0)
	            {
	                // Recherche les flags WRAP dans les messages OUT OF PLAYFIELD
	                fWrap = 0;
	                ss = listPointers[uil - EVTNUM(-12 << 16)];     // CNDL_EXTOUTPLAYFIELD
	                if (ss != 0)
	                {
	                    while (eventPointersGroup[ss] != null)
	                    {
	                        evgPtr = eventPointersGroup[ss];
	                        evtPtr = evgPtr.evgEvents[eventPointersCnd[ss]];
	                        d = (PARAM_SHORT(evtPtr.evtParams[0])).value;	// Prend la direction
	                        for (act = evg_FindAction(evgPtr, 0), n=evgPtr.evgNAct; n>0; n--, act++)
	                        {
	                            evtPtr = evgPtr.evgEvents[act];
	                            if (evtPtr.evtCode == ((8 << 16) | (oilPtr.oilType & 0xFFFF)) ) // ACT_EXTWRAP
	                            {
	                                fWrap |= d;
	                            }
	                        }
	                        ss++;
	                    }
	                }
	                oilPtr.oilWrap = fWrap;
	
	                // Fabrique la table de limitations des mouvements
	                // ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	                oi1 = oilPtr.oilOi;
	                for (colList = 0  , limitPos=0; colBuffer[colList] != -1; colList += 2)
	                {
	                    if (colBuffer[colList] == oi1)
	                    {
	                        oi2 = colBuffer[colList + 1];
	                        if ((oi2 & 0x8000) != 0)
	                        {
	                            oilPtr.oilLimitFlags |= oi2;
	                            continue;
	                        }
	                        for (limitCur = 0; limitCur < limitPos && limitBuffer[limitListStart + limitCur] != oi2; limitCur++)
								;
	                        if (limitCur == limitPos)
	                        {
	                            limitBuffer[limitListStart + limitPos++] = oi2;
	                        }
	                    }
	                }
	                // Marque la fin...
	                if (limitPos > 0)
	                {
	                    oilPtr.oilLimitList = limitListStart;
	                    limitBuffer[limitListStart + limitPos++] = -1;
	                    limitListStart += limitPos;
	                }
	            }
	        }
	
	        // Met les adresses des tables de pointeur systeme
	        // ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	        rhEvents[0] = 0;
	        for (n = 1; n <= COI.NUMBEROF_SYSTEMTYPES; n++)
	        {
	            rhEvents[n] = aListPointers[COI.NUMBEROF_SYSTEMTYPES - n];
	        }
	
	        // Poke les adresses et les autres flags des pointeurs dans tous les objets definis
	        // ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	        for (oil = 0; oil < rhPtr.rhMaxOI; oil++)
	        {
	            oilPtr = rhPtr.rhOiList[oil];
	
	            // Explore tous les objets de meme OI dans le programme
	            o = oilPtr.oilObject;
	            if ((o & 0x80000000) == 0)
	            {
	                do
	                {
	                    // Met les oi dans les ro
	                    hoPtr = rhPtr.rhObjectList[o];
	                    hoPtr.hoEvents = oilPtr.oilEvents;
	                    hoPtr.hoOiList = oilPtr;
	                    hoPtr.hoLimitFlags = oilPtr.oilLimitFlags;
	                    // Flags Wrap pour les objets avec movement
	                    if ((hoPtr.hoOEFlags & CObjectCommon.OEFLAG_MOVEMENTS) != 0)
	                    {
	                        hoPtr.rom.rmWrapping = oilPtr.oilWrap;
	                    }
	                    // Si le sprite n'est pas implique dans les collisions -> le passe en neutre
	                    if ((hoPtr.hoOEFlags & CObjectCommon.OEFLAG_SPRITES) != 0 && (hoPtr.hoLimitFlags & (CObjInfo.OILIMITFLAGS_QUICKCOL)) == 0)
	                    {
                            hoPtr.ros.setColFlag(false);
	                    }
	                    // Sprite en mode inbitate?
	                    if ((hoPtr.hoOEFlags & CObjectCommon.OEFLAG_MANUALSLEEP) == 0)
	                    {
	                        // On detruit... sauf si...
	                        hoPtr.hoOEFlags &= ~CObjectCommon.OEFLAG_NEVERSLEEP;
	
	                        // On teste des collisions avec le decor?
	                        if ((hoPtr.hoLimitFlags & CObjInfo.OILIMITFLAGS_QUICKBACK) != 0)
	                        {
	                            // Si masque des collisions general
	                            if ((rhPtr.rhFrame.leFlags & CRunFrame.LEF_TOTALCOLMASK) != 0)
	                            {
	                                hoPtr.hoOEFlags |= CObjectCommon.OEFLAG_NEVERSLEEP;
	                            }
	                        }
	                        // Ou test des collisions normal
	                        if ((hoPtr.hoLimitFlags & (CObjInfo.OILIMITFLAGS_QUICKCOL | CObjInfo.OILIMITFLAGS_QUICKBORDER)) != 0)
	                        {
	                            hoPtr.hoOEFlags |= CObjectCommon.OEFLAG_NEVERSLEEP;
	                        }
	                    }
	                    o = hoPtr.hoNumNext;
	                } while ((o & 0x80000000) == 0);
	            }
	        }
	        // Les messages speciaux
	        // ~~~~~~~~~~~~~~~~~~~~~
	        if (evtAlways != 0)
	        {
	            rhEventAlways = true;
	        }
	        else
	        {
	            rhEventAlways = false;
	        }
	        // Messages Timer (a bulle!)
	        if (aTimers != 0)
	        {
	            rh4TimerEventsBase = aTimers;
	        }
	        else
	        {
	            rh4TimerEventsBase = 0;
	        }
	
	        // Liberation
	        colBuffer = null;
	        bReady = true;
	    }

	    public function unBranchPrograms():void
	    {
	        bReady = false;
	        qualToOiList = null;
	        limitBuffer = null;
	        listPointers = null;
	        eventPointersGroup = null;
	        eventPointersCnd = null;
	    }

	    // Poke l'adresse de l'curFrame.m_oiList / qualOiList en fonction d'un oi/qual
	    public function get_OiListOffset(oi:int, type:int):int
	    {	
	        // Un qualifier
	        if ((oi & COI.OIFLAG_QUALIFIER) != 0)
	        {
	            var q:int;
	            for (q = 0; oi != qualifiers[q].qOi || type != qualifiers[q].qType; q++)
	            ;
	            return (q | 0x8000);
	        }
	        // Un objet normal
	        else
	        {
	            var n:int;
	            for (n = 0; n < rhPtr.rhMaxOI && rhPtr.rhOiList[n].oilOi != oi; n++)
					;
	            return n;
	        }
	    }

	    // Un type d'objet est-il un vrai sprite?	
	    public function isTypeRealSprite(type:int):Boolean
	    {
	        var oil:int;
	        for (oil = 0; oil < rhPtr.rhMaxOI; oil++)
	        {
	            if (rhPtr.rhOiList[oil].oilOi != -1)
	            {
	                if (rhPtr.rhOiList[oil].oilType == type)
	                {
	                    if ((rhPtr.rhOiList[oil].oilOEFlags & CObjectCommon.OEFLAG_SPRITES) != 0 && (rhPtr.rhOiList[oil].oilOEFlags & CObjectCommon.OEFLAG_QUICKDISPLAY) == 0)
	                    {
	                        return true;
	                    }
	                    else
	                    {
	                        return false;
	                    }
	                }
	            }
	        }
	        return true;
	    }

	    // Retourne les index curFrame.m_oiList des objets/qualifiers
	    // ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~	
	    public function qual_GetFirstOiList(o:int):int
	    {
	        if ((o & 0x8000) == 0)
	        {
	            qualOilPtr = -1;
	            return (o);
	        }
	        if (o == -1)
	        {
	            return -1;
	        }
	
	        o &= 0x7FFF;
	        qualOilPtr = o;
	        qualOilPos = 0;
	        return qual_GetNextOiList();
	    }

	    public function qual_GetNextOiList():int
	    {
	        var o:int;
	
	        if (qualOilPtr == -1)
	        {
	            return -1;
	        }
	        if (qualOilPos >= qualToOiList[qualOilPtr].qoiList.length)
	        {
	            return -1;
	        }
	        o = qualToOiList[qualOilPtr].qoiList[qualOilPos + 1];
	        qualOilPos += 2;
	        return (o);
	    }

	    public function qual_GetFirstOiList2(o:int):int
	    {
	        if ((o & 0x8000) == 0)
	        {
	            qualOilPtr2 = -1;
	            return (o);
	        }
	        if (o == -1)
	        {
	            return -1;
	        }
	
	        o &= 0x7FFF;
	        qualOilPtr2 = o;
	        qualOilPos2 = 0;
	        return qual_GetNextOiList2();
	    }

	    public function qual_GetNextOiList2():int
	    {
	        var o:int;
	
	        if (qualOilPtr2 == -1)
	        {
	            return -1;
	        }
	        if (qualOilPos2 >= qualToOiList[qualOilPtr2].qoiList.length)
	        {
	            return -1;
	        }
	        o = qualToOiList[qualOilPtr2].qoiList[qualOilPos2 + 1];
	        qualOilPos2 += 2;
	        return (o);
	    }

		public function addColList(oiList:int, oiNum:int, oiList2:int, oiNum2:int):void
		{
			// First object = qualifier?
			var qoil:CQualToOiList;
			var pOinOil:int;
			if ( oiNum < 0 )
			{
				if ( qualToOiList != null )
				{
					qoil=qualToOiList[oiList&0x7FFF];
					pOinOil=0;
					while(pOinOil<qoil.qoiList.length)
					{
						addColList(qoil.qoiList[pOinOil+1], qoil.qoiList[pOinOil], oiList2, oiNum2);
						pOinOil += 2;
					}
				}
				return;
			}
			
			// Second object = qualifier?
			if ( oiNum2 < 0 )
			{
				if ( qualToOiList!=null )
				{
					qoil=qualToOiList[oiList2&0x7FFF];
					pOinOil=0;
					while(pOinOil<qoil.qoiList.length)
					{
						addColList(oiList, oiNum, qoil.qoiList[pOinOil+1], qoil.qoiList[pOinOil]);
						pOinOil += 2;
					}
				}
				return;
			}
			
			// Allocate buffer 
			var colList:Array;
			var oilPtr:CObjInfo=rhPtr.rhOiList[oiList];
			if (oilPtr.oilColList==null)
			{
				oilPtr.oilColList=new Array();
				colList=oilPtr.oilColList;
			}
			else
			{
				colList = oilPtr.oilColList;
				
				var n:int;
				for (n=0; n<colList.length; n+=2)
				{
					if (oiNum2==colList[n])
					{
						return;
					}
				}
			}		
			colList.push(oiNum2);
			colList.push(oiList2);
		}
		

	    // Fabrique la liste des collisions par sprite: ouvre les qualifiers
	    // ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	    public function make_ColList1(evgPtr:CEventGroup, colList:int, oi1:int):int
	    {
	        var oi2:int;
	        var flag:int;
	        var code:int;
	        var o:int;
	        var evtPtr:CEvent;
	        var evpPtr:CParam ;
	        var evt:int;
	
	        for (evt = 0; evt < evgPtr.evgNCond; evt++)
	        {
	            evtPtr = evgPtr.evgEvents[evt];
	            if (EVTTYPE(evtPtr.evtCode) >= 2)
	            {
	                flag = (0x8000 + CObjInfo.OILIMITFLAGS_BACKDROPS);
	                code = getEventCode(evtPtr.evtCode);
	                switch (code)
	                {
	                    case (-14 << 16):         // CNDL_EXTCOLLISION:
	                        evpPtr = evtPtr.evtParams[0];
	                        for (o = qual_GetFirstOiList(evtPtr.evtOiList); o != -1; o = qual_GetNextOiList())
	                        {
	                            oi2 = rhPtr.rhOiList[o].oilOi;
	                            if (oi1 == oi2)
	                            {
	                                flag = 0;
	                                colList = make_ColList2(colList, oi1, ( PARAM_OBJECT(evpPtr) ).oiList);
	                            }
	                        }
	                        if (flag == 0)
	                        {
	                            break;
	                        }
	                        for (o = qual_GetFirstOiList(( PARAM_OBJECT(evpPtr) ).oiList); o != -1; o = qual_GetNextOiList())
	                        {
	                            oi2 = rhPtr.rhOiList[o].oilOi;
	                            if (oi1 == oi2)
	                            {
	                                colList = make_ColList2(colList, oi1, evtPtr.evtOiList);
	                            }
	                        }
	                        break;
	                    case (-12 << 16):         // CNDL_EXTOUTPLAYFIELD:
	                        evpPtr = evtPtr.evtParams[0];
	                        flag = (0x8000 + (PARAM_SHORT(evpPtr)).value);
	                    case (-13 << 16):         // CNDL_EXTCOLBACK:
	                        for (o = qual_GetFirstOiList(evtPtr.evtOiList); o != -1; o = qual_GetNextOiList())
	                        {
	                            oi2 = rhPtr.rhOiList[o].oilOi;
	                            if (oi1 == oi2)
	                            {
	                                colBuffer[colList++] = oi1;
	                                colBuffer[colList++] = flag;
	                            }
	                        }
	                        break;
	                }
	            }
	        }
	        return (colList);
	    }

	    public function make_ColList2(colList:int, oi1:int, ol:int):int
	    {
	        var oi2:int;
	        var o:int;
	        for (o = qual_GetFirstOiList(ol); o != -1; o = qual_GetNextOiList())
	        {
	            oi2 = rhPtr.rhOiList[o].oilOi;
	
	            var pos:int;
	            for (pos = 0; pos < colList; pos += 2)
	            {
	                if (colBuffer[pos] == oi1 && colBuffer[pos + 1] == oi2)
	                {
	                    break;
	                }
	            }
	            if (pos == colList)
	            {
	                colBuffer[colList++] = oi1;
	                colBuffer[colList++] = oi2;
	            }
	        }
	        return colList;
	    }

	    // POSITIONNE LES FLAGS DE MASQUE DE COLLISION
	    ///////////////////////////////////////////////
	    public function getCollisionFlags():int
	    {
	        var evgPtr:CEventGroup;
	        var evtPtr:CEvent;
	        var evpPtr:CParam;
	        var evg:int, evt:int, evp:int;
	        var flag:int;
	        for (evg = 0; evg < events.length; evg++)
	        {
	            evgPtr = events[evg];
	
	            for (evt = 0; evt < evgPtr.evgNAct + evgPtr.evgNCond; evt++)
	            {
	                evtPtr = evgPtr.evgEvents[evt];
	
	                if (evtPtr.evtNParams > 0)
	                {
	                    for (evp = 0; evp < evtPtr.evtNParams; evp++)
	                    {
	                        evpPtr = evtPtr.evtParams[evp];
	                        if (evpPtr.code == 43)	    // PARAM_PASTE
	                        {
	                            var p:PARAM_SHORT = PARAM_SHORT(evpPtr);
	                            switch (p.value)
	                            {
	                                case 1:
	                                    flag |= CColMask.CM_OBSTACLE;
	                                    break;
	                                case 2:
	                                    flag |= CColMask.CM_PLATFORM;
	                                    break;
	                            }
	                        }
	                    }
	                }
	            }
	        }
	        return flag;
	    }

	    // ENUMERATION DES SONS
	    public function enumSounds(sounds:IEnum):void
	    {
	        var evgPtr:CEventGroup;
	        var evtPtr:CEvent;
	        var evg:int, evt:int, p:int;
	        var pSample:PARAM_SAMPLE;
	
	        for (evg = 0; evg < nEvents; evg++)
	        {
	            evgPtr = events[evg];
	            for (evt = 0; evt < evgPtr.evgNCond + evgPtr.evgNAct; evt++)
	            {
	                evtPtr = evgPtr.evgEvents[evt];
	                for (p = 0; p < evtPtr.evtNParams; p++)
	                {
	                    switch (evtPtr.evtParams[p].code)
	                    {
	                        case 6:	    // PARAM_SAMPLE
	                        case 35:    // PARAM_CNDSAMPLE
	                            pSample = PARAM_SAMPLE(evtPtr.evtParams[p]);
	                            sounds.enumerate(pSample.sndHandle);
	                            break;
	                    }
	                }
	            }
	        }
	    }

		// Handle key repeat
		public function HandleKeyRepeat():void
		{
			var evgPtr:CEventGroup;
			var evtPtr:CEvent;
			var evg:int, evt:int, p:int;
			
			for (evg = 0; evg < nEvents; evg++)
			{
				evgPtr = events[evg];
				for (evt = 0; evt < evgPtr.evgNCond; evt++)
				{
					evtPtr = evgPtr.evgEvents[evt];
					if (evtPtr.evtCode==((-1<<16)|0xFFFA))
					{
						evgPtr.evgInhibit=rhPtr.rhLoopCount;
						break;
					}
				}
			}
		}

	    public function evg_FindAction(evgPtr:CEventGroup, n:int):int
	    {
	        return evgPtr.evgNCond + n;
	    }
	
	    public function EVTTYPE(code:int):int
	    {
	    	var c:int=code&0xFFFF;
	    	if ((c&0x8000)!=0)
	    	{
	    		return c-65536;
	    	}
	        return c;
	    }
			
	    public function EVTNUM(code:int):int
	    {
	        return (code >> 16);
	    }
	
	    public function getEventCode(code:int):int
	    {
	        return code & 0xFFFF0000;
	    }
			
	}
}